/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../log').m('AbstractAction')
let g18n = require('../../g18n')

const CoreObject = require('../core/abstract/object')
const AbstractReaction = require('../bot/reactions/reaction')

class AbstractAction extends AbstractReaction
{

  //constructor(parent,...args)
  //{
    //super(parent,...args)
    //this._data = data
  //}

  //common routines
  static info()
  {
    return {
      code: 'abstract',
      name: g18n.t('Abstract'),   //used on big space
      shortname: g18n.t('Abstract'),//used on small space
      desc: g18n.t('Simple/short description/comment text for action'),
      help: g18n.t('Big help text for action'),
      confs: [],  //fields
      //for admin ui
      //virtual node description as
      /*
        {
          code: ....
          name: ....
          fields: [{..}]
        }
       */
      //node will be used at admin ui, to manipulate context
      context: [], //[vnode,vnode]
      faicon: 'fas fa-question',
      uicolor: 'text-warning',  //old style
      uigroup: 'yellow',        //new style

      //for admin ui relations with other reactions

      //message = as main reaction only
      //reaction = as subreaction only
      //any = can be any
      mode: 'any', 
      //can be only one in action/message/page/etc block
      greedy: true,
      //codes of reactions, can't use together in same action/message/page/etc block
      conflicts: [],
      //can be used only when other reaction with 'doSend:true' exists
      requireSend: false,
      //this reaction do some real whatever sending via interface
      doSend: false,

      //for admin ui access by routers
      //by default will be enabled everythere.

      //should contain router type codes
      //action can be used only on limited types of routers
      routersLimit: [],
      //action can not be used at this types of routers
      routersConflict: []
    }
  }

  //init(ctx)
  //{
    //return Rx.of(null)
  //}

  execute(ctx,...data)
  {
    return Rx.of(null)
  }

  /*
  loadConfs(ctx)
  {
    return Rx.Observable.create(obs=>{
      let inf = this.constructor.info()
      let ret = {}
      if (!inf||!Array.isArray(inf.confs)||!inf.confs.length)
        return this.obsEnd(obs,ret)
          //ctx.selectorResult(data.user),
      let data = JSON.parse(this._data.data[0])
      if (!data||!data[inf.code])
        return this.obsEnd(obs,ret)
      data = data[inf.code]
      //console.log(['loadActionConfs',data])
      let $t = inf.confs.map(cfg=>{
        return ctx.selectorResult(data[cfg.code],cfg).pipe(RxO.map(v=>{
          ret[cfg.code] = v
          return v
        }))
      })
      Rx.concat(...$t).subscribe(_=>{},err=>{
        this.obsEnd(obs,ret)
      },_=>{
        this.obsEnd(obs,ret)
      })
    })
  }
  /**/

}

module.exports = AbstractAction
