/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../log').m('ActionsModule')
let g18n = require('../../g18n')

const CoreModule = require('../core/abstract/module')

class ActionsModule extends CoreModule
{

  constructor(...args)
  {
    super(...args)

    this._actions = {}
  }

  actionsTypes()
  {
    return Object.keys(this._actions).map(x=>this._actions[x].info())
  }

  registerAction(Action)
  {
    let inf = Action.info()
    this._actions[inf.code] = Action
  }

  /*
  moduleInit()
  {
    return Rx.Observable.create(obs=>{
      this.obsEnd(obs)
    })
  }
  */

  executeActions(alist,ctx)
  {
    if(!alist||!alist.length)
      return Rx.of(true)
    //alist.forEach(l=>{
      //console.log(l,l.reactions)
    //})
    let $t = alist.map(action=>{
      return this.M('logic').testLogicDirectRx(action.logic,ctx).pipe(
        RxO.mergeMap(lt=>{
          if (!lt) return Rx.of(null)
          let $tt = action.reactions.map(rct=>{
            let Cls = this._actions[rct.category]
            if (!Cls) return null
            let mdl = {}
            Object.keys(rct).forEach(k=>{
              mdl[k] = [rct[k]]
              if (k=='data')
                mdl[k] = [JSON.stringify(rct[k])]
            })
            let rrct = new Cls(this.C('screenreaction'),mdl)
            return rrct.execute(ctx)
          }).filter(x=>!!x)
          return Rx.concat(...$tt).pipe(RxO.last())
        })
      )
    }).filter(x=>!!x)
    return Rx.concat(...$t).pipe(RxO.last())
  }
}


module.exports = ActionsModule
