/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('PasswordField')
let g18n = require('../../../g18n')

const AbstractField = require('../../field/field')

class PasswordField extends AbstractField
{
  static schema(info,sch={}) {
    sch.type = String
    return sch
  }

  static info()
  {
    return {
      code: 'password',
      name: g18n.t('Password')
    }
  }

  _v2db(v) {
    if(typeof v == 'undefined'||v===null) return null
    if(typeof v != 'string') return v.toString()
    return v
  }
  _db2v(db) {
    if(typeof(db)=='undefinded'||db===null) return null
    return db
  }
}

module.exports = PasswordField
