/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('UserInGroupAccessTest')
let g18n = require('../../../g18n')

const AbstractTest = require('../../logic/abstract/test')
const User = require('../user/user')

class UserInGroupAccessTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'useringroup',
      invert: true,
      name: g18n.t('User in group'),
      iname: g18n.t('User not in group'),
      types: ['relation'],
      xtypes: ['relation:user'],
      ops: [{
        type: 'string',
        name: g18n.t('group code'),
        manual: true
      }],
      scope: 'context'
    }
  }

  test(ctx,dataTarget)
  {
    return Rx.Observable.create(obs=>{
      let fin = false
      //let inf = this.constructor.info()
      dataTarget.data().pipe(
        RxO.mergeMap(u=>{
          if (!(u instanceof User))
            return Rx.of(false)
          let grpc = this.op(0)
          return this.C('usersgroup').findNodes({users:{$in:[u.id()]}}).pipe(RxO.map(list=>{
            //console.log(['list groups',list.map(x=>x.toObject())])
            if (grpc == 'guests'&&(!list||!list.length))
              return true
            if (!Array.isArray(list))
              return false
            return list.reduce((acc,x)=>x.f('code')==grpc?true:acc,false)
          }))
        }),
        RxO.map(tr=>{
          if (!!this._conf.invert)
            tr = !tr
          return tr
        })
      ).subscribe(tr=>{
        dataTarget.accumulate(tr,ar=>{
          fin = ar
        })
      },err=>{
        log.err('abstract test err')
        console.log(err)
        this.obsEnd(obs,!!this._conf.invert)
      },()=>{
        //log.warn('abstract test result',[inf.code,this.op(),fin])
        //let ret = !!this._conf.invert?!fin:fin
        this.obsEnd(obs,fin)
      })
    })
  }


}

module.exports = UserInGroupAccessTest

