/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('UserIsGuestAccessTest')
let g18n = require('../../../g18n')

const AbstractTest = require('../../logic/abstract/test')
const User = require('../user/user')

class UserIsGuestAccessTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'userisguest',
      invert: true,
      name: g18n.t('User is guest'),
      iname: g18n.t('User is not guest'),
      types: ['relation'],
      xtypes: ['relation:user'],
      ops: [],
      scope: 'context'
    }
  }

  test(ctx,dataTarget)
  {
    return Rx.Observable.create(obs=>{
      let fin = false
      //let inf = this.constructor.info()
      dataTarget.data().pipe(
        RxO.mergeMap(u=>{
          //console.log(['isguesttest',u.iisGuest()])
          if (!(u instanceof User))
            return Rx.of(true)
          return Rx.of(u.iisGuest())
        }),
        RxO.map(tr=>{
          if (!!this._conf.invert)
            tr = !tr
          return tr
        })
      ).subscribe(tr=>{
        dataTarget.accumulate(tr,ar=>{
          fin = ar
        })
      },err=>{
        log.err('user is guest test err')
        console.log(err)
        this.obsEnd(obs,!!this._conf.invert)
      },()=>{
        //log.warn('abstract test result',[inf.code,this.op(),fin])
        //let ret = !!this._conf.invert?!fin:fin
        this.obsEnd(obs,fin)
      })
    })
  }


}

module.exports = UserIsGuestAccessTest

