/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('CurrentUserGenerator')
let g18n = require('../../../g18n')

const AbstractGenerator = require('../../field/generator')

class CurrentUserGenerator extends AbstractGenerator
{

  static info()
  {
    return {
      code: 'currentuser',
      name: g18n.t('Current user'),
      types: ['relation:user'],
      ops: []
    }
  }

  generate(ctx)
  {
    return Rx.Observable.create(obs=>{
      let u = ctx.user() || null
      this.obsEnd(obs,u)
    })
  }

}

module.exports = CurrentUserGenerator

