/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('UsersGroup')
let g18n = require('../../../g18n')

const Node = require('../../node/node')

class UsersGroup extends Node
{
  addUser(user)
  {
    if (this.f('code')=='guests') return
    if (this.hasUser(user)) return
    this.field('users').push(user)
  }

  delUser(user)
  {
    if (this.f('code')=='guests') return
    if (!this.hasUser(user)) return
    this.field('users').filter(u=>!user.eq(u))
  }

  hasUser(user)
  {
    let fz = this.field('users').size()
    if (!fz) return false
    return this.field('users').reduce((acc,x)=>user.eq(x)?true:acc,false)
  }

  addRole(role)
  {
    if (this.hasRole(role)) return
    this.field('roles').push(role)
  }

  delRole(role)
  {
    if (!this.hasRole(role)) return
    this.field('roles').filter(r=>!role.eq(r))
  }

  hasRole(role)
  {
    let fz = this.field('roles').size()
    if (!fz) return false
    return this.field('roles').reduce((acc,x)=>role.eq(x)?true:acc,false)
  }
}

module.exports = UsersGroup
