/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('!BotRouteField')
let g18n = require('../../../../g18n')

const AbstractField = require('../../../field/field')

class BotRouteField extends AbstractField
{
  static schema(info,sch={}) {
    sch.type = String
    return sch
  }

  static info()
  {
    return {
      code: 'botroute',
      name: g18n.t('Command/Key route'),
      conf: {
        ops: [{
          name: g18n.t('Key'),
          type: 'boolean',
          manual: true
        }]
      }
    }
  }

  xtypes()
  {
    let isBigConf = this.confOp(0,false)
    let type = this.constructor.info().code
    let ret = []
    if (isBigConf)
      ret.push(type+':big')
    else
      ret.push(type+':small')
    return ret
  }

  _v2db(v) {
    if(typeof v == 'undefined'||v===null) return null
    if(typeof v != 'string') return v.toString()
    return v
  }

  _db2v(db) {
    return db
  }

}

module.exports = BotRouteField
