/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../../log').m('FromStringModifier<any>')
let g18n = require('../../../../../g18n')

const AbstractModifier = require('../../../../field/modifier')

class FromStringModifier extends AbstractModifier
{

  static info()
  {
    return {
      code: 'fromstring',
      name: g18n.t('From text'), //getter
      iname: g18n.t('From text'), //setter
      invert: false, //cuz not invertable
      flat: true, //modifier value is single element
      strict: 'botroute', //keeps original field type
      ops: [],
      types: ['string']
    }
  }

  getNext()
  {
    let ret = this._dataTarget.one()
    if (ret===0)
      return '0'
    if (!ret)
      return ''
    if (typeof ret.toString == 'function')
      return ret.toString()
    return ret+''
  }

}

module.exports = FromStringModifier
