/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../../log').m('ToStringModifier<any>')
let g18n = require('../../../../../g18n')

const AbstractModifier = require('../../../../field/modifier')

class ToStringModifier extends AbstractModifier
{

  static info()
  {
    return {
      code: 'tostring',
      name: g18n.t('As text'), //getter
      iname: g18n.t('As text'), //setter
      invert: false, //cuz not invertable
      flat: true, //modifier value is single element
      strict: 'string', //keeps original field type
      ops: [],
      types: ['botroute']
    }
  }

  getNext()
  {
    let ret = this._dataTarget.one()
    if (ret===0)
      return '0'
    if (!ret)
      return ''
    if (typeof ret.toString == 'function')
      return ret.toString()
    return ret+''
  }

}

module.exports = ToStringModifier
