/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('ContainsTest')
let g18n = require('../../../../g18n')

const AbstractTest = require('../../../logic/abstract/test')

class ContainsTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'contains',
      name: g18n.t('Contains'),
      iname: g18n.t('Not contains'),
      invert: true,
      ops: [{
        type: 'string',
        name: g18n.t('test text'),
        manual: true
      },{
        type: 'boolean',
        name: g18n.t('/i'),
        manual: true
      }],
      types: ['string']
    }
  }

  _test(str)
  {
    let op0 = this.op()
    let isCI = this.op(1,false)
    if (!op0||!str)
      return false
    if (!isCI)
      return op0.includes(str)
    return op0.toUpperCase().includes(str.toUpperCase())
  }

  queryFor(ctx,vctx)
  {
    return Rx.Observable.create(obs=>{
      let op0 = this.op()
      let isCI = this.op(1,false)
      if (!op0)
        return this.obsEnd(obs,null)
      let rg = new RegExp(rx)
      if (isCI)
        rg = new RegExp(rx,'i')
      let tgt = this.dataTarget().targetCode()
      let ret = {}
      ret[tgt] = { $regex: rg }
      if (this._conf.invert)
        ret = {$nor:[ret]}
      return this.obsEnd(obs,ret)
    })
  }





}

module.exports = ContainsTest
