/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('EqTest')
let g18n = require('../../../../g18n')

const AbstractTest = require('../../../logic/abstract/test')

class EqTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'eq',
      name: g18n.t('Equal'),
      iname: g18n.t('Not equal'),
      invert: true,
      ops: [{
        type: 'string',
        name: g18n.t('to'),
        manual: true
      },{
        type: 'boolean',
        name: g18n.t('/i'),
        manual: true
      }],
      types: ['string']
    }
  }

  _test(str)
  {
    let other = this.op()
    let isCI = this.op(1,false)
    if (!other||!str)
      return false
    if (!isCI)
      return str==other
    return other.toUpperCase()==str.toUpperCase()
  }

  queryFor(ctx,vctx)
  {
    return Rx.Observable.create(obs=>{
      let other = this.op()
      let isCI = this.op(1,false)
      let tgt = this.dataTarget().targetCode()
      let ret = {}
      if (!isCI)
        ret[tgt]=other
      else
        ret[tgt] = { $regex: new RegExp('^'+other+'$','i') } 
      if (this._conf.invert)
        ret = {$nor: [ret] }
      return this.obsEnd(obs,ret)
    })
  }



}

module.exports = EqTest
