/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../../../log').m('ExecReaction')
let g18n = require('../../../../g18n')

const AbstractReaction = require('../reaction')

class ExecReaction extends AbstractReaction
{

  static info()
  {
    return {
      code: 'exec',
      name: g18n.t('Execute other screen bot reaction'),
      shortname: g18n.t('Exec'),
      faicon: 'fas fa-code-branch',
      uicolor: 'text-info',
      uigroup: 'helpers',
      routersLimit: ['telegrambotrouter'],
      mode: 'any', //message/reaction/any
      greedy: false,
      conflicts: [],
      requireSend: false,
      doSend: false
    }
  }


  execute(ctx,$msg)
  {
    return Rx.Observable.create(obs=>{
      let data = this.f('data')
      if (!data||!data.exec)
        return this.obsEnd(obs)
      //console.log(['exec',data.exec])
      //let str = this._tokens(data.text)
      let srch = [Rx.of(null)]
      let cmd = ctx.cmd().clone()
      if (data.exec.mode=='sid')
      {
        srch = [this.C('screen').findNode({_id:data.exec.sid},{populate:2}).pipe(RxOps.map($sc=>{
          if (!$sc) return null
          return {
            argi: -1,
            scr: $sc
          }
        }))]
      }
      if (data.exec.mode=='args'&&ctx.cmd().args().length)
      {
        if (data.exec.dashes)
          cmd.rearg('-')
        let argi = parseInt(data.exec.argi) || 0
        //console.log(cmd.args())
        //console.log(['search from arg',argi,cmd.arg(argi)])
        if (argi)
        {
          if (cmd.arg(argi))
            srch = [this.C('screen').findNode({_id:cmd.arg(argi)},{populate:2}).pipe(RxOps.map($sc=>{
              if (!$sc) return null
              return {
                argi: argi,
                scr: $sc
              }
            }))]
        } else {
          srch = []
          cmd.args().forEach((arg,ai)=>{
            if (!ai) return
            srch.push(this.C('screen').findNode({_id:arg},{populate:2}).pipe(RxOps.map($sc=>{
              if (!$sc)
                return null
              return {
                argi: ai,
                scr: $sc
              }
            })))
          })
        }
      }
      let scr = null
      //console.log(['searching to exec',srch])
      Rx.concat(...srch).subscribe(res=>{
        if (res&&!scr)
          scr = res
      },err=>{},()=>{
        //search comlete
        //console.log(['exec',[scr]])
        if (!scr)
          return this.obsEnd(obs)
        let nextCtx = ctx.cloneDepth()
        if (scr.argi!=-1)
          cmd.dropArg(scr.argi)
        let parsecmd = Rx.of(cmd.raw())
        if (data.exec.argsLine!='')
          parsecmd = this.M('template').compile(data.exec.argsLine,ctx)
        parsecmd.subscribe(newcmdline=>{
          cmd._parse(newcmdline)
          nextCtx.cmd(cmd)
          let ev = Rx.of(1)
          if (data.exec.after)
            ev = ctx.done
          ctx.f('executed',ctx.f('executed')+1)
          //ctx._stats.executed++
          ev.subscribe(()=>{
            scr.scr.execute(nextCtx).subscribe(res=>{
              if (!data.exec.after)
                this.obsEnd(obs)
            },err=>{
              if (!data.exec.after)
                this.obsEnd(obs)
            })
          })
          if (data.exec.after)
            this.obsEnd(obs)
        })
      })

    })
  }

}

module.exports = ExecReaction
