/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../../../log').m('ExecReactionModule')
let g18n = require('../../../../g18n')

const CoreModule = require('../../../core/abstract/module')

const ExecReaction = require('./exec')

class ExecReactionModule extends CoreModule
{
  constructor(parent)
  {
    super(parent)

    this._reactionClasses = {}

    this.M('bot/reactions').registerReactionType(ExecReaction)
    this.M('actions').registerAction(ExecReaction)
  }

  dashboardRoutes(app)
  {
    return Rx.Observable.create(obs=>{

      //reactions ROUTES

      let rteExec = {
        url: '/api/reaction/exec/screenslist',
        access: 'auth.dashboard',
        method: 'get',
        fn: (ctx)=>{
          return Rx.Observable.create(obs=>{
            
            //  TODO

            //  currently - returns all, without checking access

            this.C('screengroup').findNodes({},{populate:1}).subscribe(list=>{
              let ret = []
              list.forEach(scg=>{
                ret.push(scg.toObject())
                /*
                scg.field('screens').forEach($sc=>{
                  if (!$sc) return
                  if ($sc.f('action')!='text') return
                  let ad = $sc.f('actionData')
                  if (!ad||!ad.text) return
                  if (!ad.text.hasKey||!ad.text.key.length) return
                  let k = {
                    type:'screen',
                    sid: $sc.id(),
                    key: ad.text.key,
                    command: '',
                    title: $sc.f('title'),
                    group: scg.f('code'),
                    groupName: scg.f('name')
                  }
                  ret.push(k)
                })
                /**/
              })
              this.obsEnd(obs,ret)
            },err=>{
              log.err('fail search groups')
              console.log(err)
              this.obsEnd(obs,[])
            })
          })
        }
      }


      this.obsEnd(obs,[
        rteExec
      ])
    })
  }


}

module.exports = ExecReactionModule
