/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../../../log').m('GroupReactionModule')
let g18n = require('../../../../g18n')

const CoreModule = require('../../../core/abstract/module')

const GroupReaction = require('./group')

class GroupReactionModule extends CoreModule
{
  constructor(parent)
  {
    super(parent)

    this.M('bot/reactions').registerReactionType(GroupReaction)
    this.M('actions').registerAction(GroupReaction)
  }

  dashboardRoutes(app)
  {
    return Rx.Observable.create(obs=>{

      //reactions ROUTES

      let rteGroups = {
        url: '/api/authreaction/groups',
        access: 'auth.dashboard',
        method: 'get',
        fn: (ctx)=>{
          return this.C('usersgroup').findNodes({}).pipe(RxOps.map(x=>{
            return x.map(xx=>{
              return {
                code: xx.f('code'),
                name: xx.f('name')
              }
            })
          }))
        }
      }

      this.obsEnd(obs,[
        rteGroups
      ])
    })
  }



}

module.exports = GroupReactionModule
