/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../../../log').m('KickReactionModule')
let g18n = require('../../../../g18n')

const CoreModule = require('../../../core/abstract/module')

const KickReaction = require('./kick')

class KickReactionModule extends CoreModule
{
  constructor(parent)
  {
    super(parent)

    this._reactionClasses = {}

    this.M('bot/reactions').registerReactionType(KickReaction)
    this.M('actions').registerAction(KickReaction)
  }

}

module.exports = KickReactionModule
