/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../../log').m('LibraryReaction')
let g18n = require('../../../../g18n')

const AbstractReaction = require('../reaction')
const Context = require('../../../context/context')

class LibraryReaction extends AbstractReaction
{

  static info()
  {
    return {
      code: 'library',
      name: g18n.t('Loads data from library'),
      shortname: g18n.t('Library'),
      faicon: 'fas fa-book',
      uicolor: 'text-info',
      uigroup: 'library',
      routersLimit: [],
      mode: 'message', //message/reaction/any
      greedy: true,
      conflicts: ['*'],
      requireSend: false,
      doSend: false
    }
  }


  execute(ctx,$msg)
  {
    return Rx.of(this.f('data')).pipe(
      RxO.mergeMap(data=>{
        if (!data||!data.library)
          return Rx.of(null)
        return this.M('logic').library(ctx,data.library)
      })
    )
  }

}

module.exports = LibraryReaction
