/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('LoopReaction')
let g18n = require('../../../../g18n')

let uuid = require('uuid-v4')
let UA = require('universal-analytics')

const AbstractReaction = require('../reaction')

class LoopReaction extends AbstractReaction
{

  static info()
  {
    return {
      code: 'loop',
      name: g18n.t('Loop other reactions'),
      shortname: g18n.t('Loop'),
      faicon: 'fas fa-sync-alt',
      uicolor: '',
      uigroup: 'helpers',
      routersLimit: ['telegrambotrouter'],
      mode: 'message', //message/reaction/any
      greedy: true,
      conflicts: [],
      requireSend: false,
      doSend: false
    }
  }


}

module.exports = LoopReaction
