/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../../../log').m('LoopReactionModule')
let g18n = require('../../../../g18n')

const CoreModule = require('../../../core/abstract/module')

const LoopReaction = require('./loop')

class LoopReactionModule extends CoreModule
{
  constructor(parent)
  {
    super(parent)

    this._reactionClasses = {}

    this.M('bot/reactions').registerReactionType(LoopReaction)
    this.M('actions').registerAction(LoopReaction)
  }

}

module.exports = LoopReactionModule
