/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../../../log').m('NodeReactionModule')
let g18n = require('../../../../g18n')

const CoreModule = require('../../../core/abstract/module')

const NodeReaction = require('./node')
const UpdateNodeReaction = require('./update')
const RemoveNodeReaction = require('./remove')

class NodeReactionModule extends CoreModule
{
  constructor(parent)
  {
    super(parent)

    this._reactionClasses = {}

    this.M('bot/reactions').registerReactionType(NodeReaction)
    this.M('bot/reactions').registerReactionType(UpdateNodeReaction)
    this.M('bot/reactions').registerReactionType(RemoveNodeReaction)
    this.M('actions').registerAction(NodeReaction)
    this.M('actions').registerAction(UpdateNodeReaction)
    this.M('actions').registerAction(RemoveNodeReaction)
  }

}

module.exports = NodeReactionModule
