/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('TextReaction')
let g18n = require('../../../../g18n')

const AbstractReaction = require('../reaction')

class TextReaction extends AbstractReaction
{

  static info()
  {
    return {
      code: 'text',
      name: g18n.t('Telegram formatted text'),
      shortname: g18n.t('TG text'),
      desc: g18n.t('Sends text message'),
      help: g18n.t('Sends text message'),
      faicon: 'fas fa-pencil-alt',
      uicolor: 'text-primary',
      uigroup: 'tgmessage',
      routersLimit: ['telegrambotrouter'],
      mode: 'any', //message/reaction/any
      greedy: true,
      conflicts: ['file'],
      requireSend: false,
      doSend: true
    }
  }

  _tokens(str)
  {
    //user
    //str = str.replace('{user:name}','{{ user.firstName }}')
    //str = str.replace('{user:onetimelogin}','{{ virtual.otlCode }}')

    return str
  }

  execute(ctx,$msg)
  {
    return Rx.Observable.create(obs=>{
      //console.log(['exec text'])
      let data = this.f('data')
      if (!data||!data.text)
        return this.obsEnd(obs)
      let str = this._tokens(data.text)
      log.test('templating',str)
      //console.log(ctx.view())
      this.M('template').compile(str,ctx).subscribe(res=>{
        $msg.f('text',res)
        this.obsEnd(obs)
      })
    })
  }

}

module.exports = TextReaction
