/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('TGMsgEditReaction')
let g18n = require('../../../../g18n')

const AbstractReaction = require('../reaction')

class TGMsgEditReaction extends AbstractReaction
{

  static info()
  {
    return {
      code: 'tgmsgedit',
      name: g18n.t('TG Message Edit'),
      shortname: g18n.t('TGM Edit'),
      desc: g18n.t('Edit message from telegram chat history'),
      help: g18n.t('Message to edit should exists in context'),
      faicon: 'fas fa-edit',
      uicolor: 'text-danger',
      uigroup: 'chatadmin',
      routersLimit: ['telegrambotrouter'],
      mode: 'message', //message/reaction/any
      greedy: false,
      conflicts: ['file'],
      requireSend: false,
      doSend: false,
      confs: [{
        name: g18n.t('message'),
        code: 'target',
        desc: g18n.t('Telegram message to update'),
        allowManual: false,
        allowGenerators: false,
        type: 'relation',
        xtype: 'relation:tgmessage'
      }]
    }
  }

  execute(ctx,$msg)
  {
    return Rx.Observable.create(obs=>{
      let data = this.f('data')
      return this.obsEnd(obs)
    })
  }

}

module.exports = TGMsgEditReaction
