/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../../../log').m('TGMsgReactionModule')
let g18n = require('../../../../g18n')

const CoreModule = require('../../../core/abstract/module')

const TGRDel = require('./del')
const TGREdit = require('./edit')
const TGMEdit = require('./edit.msg')

const TGMIA = require('./inlineqa')
const TGMIAmsg = require('./inlineqa.msg')

class TGMsgReactionModule extends CoreModule
{
  constructor(parent)
  {
    super(parent)
  }

  moduleInit()
  {
    return Rx.Observable.create(obs=>{
      this.M('bot/reactions').registerReactionType(TGREdit)
      this.M('bot/reactions').registerReactionType(TGRDel)
      this.M('bot/reactions').registerReactionType(TGMIA)
      this.M('bot/messages').registerMessageType('tgmsgedit',TGMEdit)
      this.M('bot/messages').registerMessageType('tginlineanswer',TGMIAmsg)
      this.M('actions').registerAction(TGREdit)
      this.M('actions').registerAction(TGRDel)
      this.M('actions').registerAction(TGMIA)
      this.obsEnd(obs)
    })
  }

}

module.exports = TGMsgReactionModule
