/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../../../log').m('UserLoginReactionModule')
let g18n = require('../../../../g18n')

const CoreModule = require('../../../core/abstract/module')

const UserLoginReaction = require('./login')
const IfaceLoginReaction = require('./iflogin')

class UserLoginReactionModule extends CoreModule
{

  constructor(parent)
  {
    super(parent)

    this._reactionClasses = {}

    this.M('bot/reactions').registerReactionType(UserLoginReaction)
    this.M('bot/reactions').registerReactionType(IfaceLoginReaction)
    this.M('actions').registerAction(UserLoginReaction)
    this.M('actions').registerAction(IfaceLoginReaction)
  }

}

module.exports = UserLoginReactionModule
