/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('ScreenGroup')
let g18n = require('../../../../g18n')

const Node = require('../../../node/node')

class ScreenGroupNode extends Node
{

  constructor(parent,model,isNew=false)
  {
    super(parent,model,isNew)
    this._type = 'screengroupnode'
  }

  /**/
  afterSave()
  {
    return Rx.Observable.create(obs=>{
      log.info('afterSave')
      if (!this._new)
        return this.obsEnd(obs,this)
      log.info('afterSave creating roles')
      let $t = []
      let code = this.f('code')
      //need create roles
      $t.push(this.M('auth/role').roleSave('screengroup',code+':read',g18n.t('Dashboard read access to')+' '+this.f('name')))
      $t.push(this.M('auth/role').roleSave('screengroup',code+':write',g18n.t('Dashboard write access to')+' '+this.f('name')))
      $t.push(this.M('auth/role').roleSave('screengroup',code+':private',g18n.t('Bot users private access to')+' '+this.f('name')))
      $t.push(this.M('auth/role').roleSave('screengroup',code+':group',g18n.t('Bot users group access to')+' '+this.f('name')))
      $t.push(this.M('auth/role').roleSave('screengroup',code+':supergroup',g18n.t('Bot users supergroup access to')+' '+this.f('name')))
      //and update admins
      $t.push(this.M('auth/access').updateAdminsAccess())
      Rx.concat(...$t).subscribe(res=>{
        //log.info('...')
      },err=>{
        log.err('afterSave screengroup tasks FAILED')
        console.log(err)
        this.obsErr(obs,err)
      },()=>{
        log.success('afterSave complete')
        this.obsEnd(obs,this)
      })
    })
  }
  /**/

}

module.exports = ScreenGroupNode
