/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../../log').m('AbstractScreen')
let g18n = require('../../../g18n')

const Node = require('../../node/node')
const ScreenGroup = require('./group/node')

class AbstractScreen extends Node
{

  constructor(parent,model,isNew=false)
  {
    super(parent,model,isNew)
    this._type = 'screen'
    this._screengroup = null
  }

  screengroup(val)
  {
    if(val&&(val instanceof ScreenGroup))
      this._screengroup = val
    return this._screengroup
  }

  title()
  {
    return this.f('title')
  }

  execute(ctx)
  {
    return Rx.Observable.create(obs=>{
      setTimeout(()=>{
        ctx.screen(this)
        log.info('executing',this.title())
        let $t = []
        this.field('messages').forEach((msg,msgi)=>{
          msg.msgI(msgi)
          msg.screen(this)
          //console.log(msg.toObject())
          //console.log(['!!!',[msg]])
          $t.push(msg.execute(ctx).pipe(RxOps.catchError(err=>{
            log.err('action/message execution error')
            console.log(err)
            ctx.f('error',ctx.f('error')+1)
            return Rx.of(null)
          })))
        })
        Rx.concat(...$t).subscribe(res=>{
          //log.info('message executed',res)
        },err=>{
          log.err('executing messages error!')
          console.log(err)
          this.obsEnd(obs,{success:false,error:err})
        },()=>{
          ctx.done.next()
          log.info('executed',[ctx._stats])
          this.obsEnd(obs,{success:true})
        })
      },0)
    })
  }

}

module.exports = AbstractScreen
