/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let crypto = require('crypto')

mongoose = require('mongoose')

var BundleSchema = mongoose.Schema({
  name: {
    //type: Map,
    //of: String,
    type: String,
    required: true
  },
  code: {
    type: String,
    required: true,
    unique: true,
    index: true
  },
  desc: {
    //type: Map,
    //of: String,
    type: String,
    required: false
  },
  flags: {
    type: [String],
    default: []
  },
  prefix: {
    type: String,
    required: true,
    default: 'b_'
  },
  /* ======= */
  fields: [{
    /* BUNDLE FIELD SCHEMA */
    name: {
      //type: Map,
      //of: String,
      type: String,
      required: true
    },
    code: {
      type: String,
      required: true
    },
    desc: {
      //type: Map,
      //of: String,
      type: String,
      required: false,
    },
    mapped: {
      type: Boolean,
      default: false
    },
    type: {
      type: String,
      required: true
    },
    flags: {
      type: [String],
      default: []
    },
    generator: {
      type: String,
      default: null
    },
    quantity: {
      type: Number,
      default: 1
    },
    def: {
      type: mongoose.Schema.Types.Mixed
    },
    conf: {
      type: mongoose.Schema.Types.Mixed,
      default: null
    }
   /* ======= */
  }]
  /**/
})


module.exports = mongoose.model('MgBundle',BundleSchema)
