/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('CoreObject')

class CoreObject
{
  constructor(parent=null)
  {
    this._parent = parent

    this.signals = {}

    this._core = parent
    if (this._parent && this._parent._core)
      this._core = this._parent._core
  }

  obsEnd(obs,res)
  {
    if (!obs||typeof(obs.next)!='function')
      log.err('PASS OBS TO obsEnd, stupid.')
    obs.next(res)
    obs.complete()
  }

  obsErr(obs,err)
  {
    if (!obs||typeof(obs.next)!='function')
      log.err('PASS OBS TO obsErr, stupid.')
    obs.error(err)
  }

  M(code)
  {
    if (this._core&&this._core.module)
      return this._core.module(code)
    return null
  }

  C(code)
  {
    let b = this.M('bundle')
    if (!b) return null
    return b.collection(code)
  }
}

module.exports = CoreObject
