/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('AnyAsStringModifier<any>')
let g18n = require('../../../../g18n')

const AbstractModifier = require('../../modifier')

class AnyAsStringModifier extends AbstractModifier
{

  static info()
  {
    return {
      code: 'asstring',
      name: g18n.t('As string'), //getter
      iname: g18n.t('As string'), //setter
      invert: false, //cuz not invertable
      flat: true, //modifier value is single element
      strict: 'string', //keeps original field type
      ops: [{
        //type: 'boolean',
        //name: g18n.t('float'),
        //manual: true
      //},{
        //type: 'number',
        //name: g18n.t('digits'),
        //manual: true,
        //def: 2
      //},{
        type: 'string',
        name: g18n.t('at path'),
        manual: true,
        canNone: true
      }],
      types: ['any']
    }
  }

  getNext()
  {
    let nx = this._dataTarget.one()
    let path = this.op(0,'')
    let ret
    if (path.length)
    {
      let paths = path.split('.')
      while(paths.length)
      {
        let p = paths.shift()
        if (!p.length)
          break
        if (typeof nx[p] == 'undefined')
          break
        nx = nx[p]
        ret = nx
      }
    } else {
      ret = nx
    }
    //console.log(['asstr',path,nx,ret])
    if (typeof ret == 'undefined')
      return ret
    if (typeof ret.toString == 'function')
      return ret.toString()
    return ret+''
  }



}

module.exports = AnyAsStringModifier
