/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('AnyOneModifier')
let g18n = require('../../../../g18n')

const AbstractModifier = require('../../modifier')

class AnyOneModifier extends AbstractModifier
{

  static info()
  {
    return {
      code: 'anyone',
      name: g18n.t('Any one'),
      iname: '',  //not required for 'array only' tests
      invert: false, //cuz not invertable
      flat: true, //modifier result is single element
      strict: '',
      ops: [],
      types: ['[]']
    }
  }

  getNext()
  {
    return this._dataTarget.one(this.pos())
  }

  reset()
  {
    this.pos(0)
  }

  accumulate(exRes)
  {
    let pos = this.pos()
    let size = this._dataTarget.size()
    let q = this._dataTarget.quantity()
    let max = q>1?q:size
    pos++
    let stop = false
    if (pos>=max)
      stop = true
    if (exRes)
      stop = true
    if (!stop)
      this.pos(pos)
    return {
      stop: stop,
      res: exRes
    }
  }



}

module.exports = AnyOneModifier
