/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('AtPathModifier<any>')
let g18n = require('../../../../g18n')

const AbstractModifier = require('../../modifier')

class AtPathModifier extends AbstractModifier
{

  static info()
  {
    return {
      code: 'atpath',
      name: g18n.t('At path'),
      iname: '',  //not required for 'array only' tests
      invert: false, //cuz not invertable
      flat: true, //modifiers result is single element
      strict: '', //keeps original field type
      ops: [{
        type: 'string',
        name: g18n.t('Path'),
        manual: true
      }],
      types: ['any']
    }
  }

  getNext()
  {
    let path = this.op(0,null)
    let data = this._dataTarget.one()
    if (!data||!path)
      return data
    let paths = path.split('.')
    let ret
    while(paths.length)
    {
      let p = paths.shift()
      if (!p.length)
        break
      if (typeof data[p] == 'undefined')
        break
      data = data[p]
      ret = data
    }
    //log.test('path',[path,data])
    //let ret = this._dataTarget.one(pos)
    //log.warn('getNext',[pos,ret])
    return ret
    //return ret
  }


  /*
  doNext(testRes)
  {
    //log.info('doNext?',{last:testRes})
    return {
      next: true,
      res: true
    }
  }

  testMod(ctx,args)
  {
    return Rx.Observable.create(obs=>{
      let vals = this.testValues(ctx)
      let pos = parseInt(this.op(ctx))||0
      let val = vals[pos]

      console.log(['testing mod ATPOS',val,[this._next]])
      log.err('abstract mod test allways FAIL')
      this.obsEnd(obs,false)
    })
  }

  testValues(ctx)
  {
    let pos = parseInt(this.op(ctx))||0
    let v = this.value(pos)
    //console.log(['atpos values',this._field.info.code,pos,v])
    return [v]
  }

  test(ctx,valI=0)
  {
    let pos = this.op(ctx)
    let next = this._next
    let ret = false
    if (!next||pos<0)
      return false //modifiers are not invertable
    return next.test(ctx,pos)
  }
  /**/

}

module.exports = AtPathModifier
