/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('AtPosModifier')
let g18n = require('../../../../g18n')

const AbstractModifier = require('../../modifier')

class AtPosModifier extends AbstractModifier
{

  static info()
  {
    return {
      code: 'atpos',
      name: g18n.t('At position'), //getter
      iname: g18n.t('At position'), //setter
      invert: false, //cuz not invertable
      flat: true, //modifiers result is single element
      strict: '', //keeps original field type
      ops: [{
        type: 'number',
        name: g18n.t('Position'),
        manual: true
      }],
      types: ['[]']
    }
  }

  setRange()
  {
    let pos = parseInt(this.op())||0
    return [pos]
  }

  getNext()
  {
    let pos = parseInt(this.op(),0)
    let ret = this._dataTarget.one(pos)
    log.warn('getNext',[pos,ret])
    return ret
  }

}

module.exports = AtPosModifier
