/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('ClearSetter')
let g18n = require('../../../../g18n')

const AbstractSetter = require('../../../logic/setter')

class ClearSetter extends AbstractSetter
{

  static info()
  {
    return {
      code: 'clear',
      name: g18n.t('Clear'),
      ops: [],
      types: ['*','[*]']
    }
  }

  setRange(range,target)
  {
    if (!range.length||range[0]==-1)
    {
      target._target.clear()
      return true
    }
    range.forEach(pos=>{
      target._target.clearAt(pos)
    })
    return true
  }

}

module.exports = ClearSetter
