/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('DoNothingSetter')
let g18n = require('../../../../g18n')

const AbstractSetter = require('../../../logic/setter')

class DoNothingSetter extends AbstractSetter
{

  static info()
  {
    return {
      code: 'donothing',
      name: g18n.t('Do nothing'),
      ops: [],
      types: ['*','[*]']
    }
  }

  setRange(range,target)
  {
    return true
  }

}

module.exports = DoNothingSetter
