/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('ExistsTest')
let g18n = require('../../../../g18n')

const AbstractTest = require('../../../logic/abstract/test')

class ExistsTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'exists',
      invert: true,
      name: g18n.t('Exists'),
      iname: g18n.t('Not exists'),
      ops: [],
      types: ['*']
    }
  }

  _test(val)
  {
    if (typeof val == 'undefined')
      return false
    if (val === null)
      return false
    if (Array.isArray(val)&&!val.length)
      return false
    //console.log(['exists?',val,'true'])
    return true
  }

  queryFor(ctx,vctx)
  {
    return Rx.Observable.create(obs=>{
      let tgt = this.dataTarget().targetCode()
      let ret = {}
      ret[tgt] = {$not:{$size:0}}
      if (this._conf.invert)
        ret[tgt] = {$size:0}
      return this.obsEnd(obs,ret)
    })
  }



}

module.exports = ExistsTest
