/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('AsArrayTest')
let g18n = require('../../../../g18n')

const AbstractTest = require('../../../logic/abstract/test')

class AsArrayTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'isarray',
      name: g18n.t('Is list'),
      iname: g18n.t('Is not list'),
      invert: true,
      ops: [{
        name: j18n.t('path'),
        type: 'string',
        manual: true
      }],
      types: ['any']
    }
  }

  _test(v)
  {
    return Array.isArray(v)
  }

}

module.exports = AsArrayTest
