/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('IsNullTest')
let g18n = require('../../../../g18n')

const AbstractTest = require('../../../logic/abstract/test')

class IsNullTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'isnull',
      invert: true,
      name: g18n.t('Is empty/null'),
      iname: g18n.t('Is not empty/null'),
      ops: [],
      types: ['*','[*]']
    }
  }

  _test(val)
  {
    //console.log(['isnull?',v])
    if (typeof val == 'undefined')
      return true
    if (val === null)
      return true
    if (Array.isArray(val)&&!val.length)
      return true
    return false
  }

  queryFor(ctx,vctx)
  {
    return Rx.Observable.create(obs=>{
      let tgt = this.dataTarget().targetCode()
      let ret = {}
      ret[tgt] = {$size:0}
      if (this._conf.invert)
        ret[tgt] = {$not:{$size:0}}
      return this.obsEnd(obs,ret)
    })
  }



}

module.exports = IsNullTest
