/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('EmptyValidator')
let g18n = require('../../../../g18n')

const AbstractValidator = require('../../validator')

class EmptyValidator extends AbstractValidator
{

  static info()
  {
    return {
      code: 'empty',
      name: g18n.t('Is empty'),
      iname: g18n.t('Is not empty'),
      types: ['*','[]','[*]'],
      ops: []
    }
  }


  validate()
  {
    return Rx.Observable.create(obs=>{
      let model = this._node._model
      let ok = true
      if (!model[this._field.code].length)
        ok = false
      if (this._conf.invert) ok = !ok
      obs.next({valid:ok})
      obs.complete()
    })
  }

}

module.exports = EmptyValidator

