/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('IsNullValidator')
let g18n = require('../../../../g18n')

const AbstractValidator = require('../../validator')

class IsNullValidator extends AbstractValidator
{

  static info()
  {
    return {
      code: 'isnull',
      name: g18n.t('Is NULL'),
      iname: g18n.t('Is not NULL'),
      types: ['*','[]','[*]'],
      ops: []
    }
  }


  validate()
  {
    return Rx.Observable.create(obs=>{
      let val = this._field.get()
      let ok = false
      if (val === null)
        ok = true
      if (this._conf.invert) ok = !ok
      obs.next({valid:ok})
      obs.complete()
    })
  }

}

module.exports = IsNullValidator
