/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('RequiredValidator')
let g18n = require('../../../../g18n')

const AbstractValidator = require('../../validator')

class RequiredValidator extends AbstractValidator
{

  static info()
  {
    return {
      code: 'required',
      name: g18n.t('Required'),
      iname: g18n.t('Not required'),
      types: ['*','[]','[*]'],
      ops: []
    }
  }

  validate()
  {
    return Rx.Observable.create(obs=>{
      let val = this._field.get()
      let ok = true
      if (typeof val == 'undefined' || val === null)
        ok = false
      if (this._conf.invert) ok = !ok
      obs.next({valid:ok})
      obs.complete()
    })
  }

}

module.exports = RequiredValidator
