/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('UniqueValidator')
let g18n = require('../../../../g18n')

const AbstractValidator = require('../../validator')

class UniqueValidator extends AbstractValidator
{

  static info()
  {
    return {
      code: 'unique',
      name: g18n.t('Is unique'),
      iname: g18n.t('Is not unique'),
      types: ['*','[]','[*]'],
      ops: []
    }
  }

  validate()
  {
    return Rx.Observable.create(obs=>{
      let val = this._field.get()
      let coll = this._node._parent
      let $and1 = {}
      $and1[this._field.code] = val
      coll.countNodes({$and:[$and1,{_id:{$ne: this._node.id() }}]}).subscribe(count=>{
        let ret = {valid:true}
        if (count > 0 )
          ret.valid = false
        if (this._conf.invert) ret.valid = !ret.valid
        obs.next(ret)
        obs.complete()
      },err=>{
        log.err('count failed')
        obs.error({valid:false,error:err})
      })
    })
  }

}

module.exports = UniqueValidator

