/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('BooleanField')
let g18n = require('../../../g18n')

const AbstractField = require('../field')

class BooleanField extends AbstractField
{
  static schema(info,schema={}) {
    schema.type = Boolean
    return schema
  }

  static info()
  {
    return {
      code: 'boolean',
      name: g18n.t('Yes/No'),
      conf: {
        ops: [{
          type: 'string',
          manual: true,
          name: g18n.t('On label'),
          def: g18n.t('Yes')
        },{
          type: 'string',
          manual: true,
          name: g18n.t('Off label'),
          def: g18n.t('No')
        }]
      }
    }
  }

  _v2db(v) {
    if(typeof v == 'undefinded'||v===null) return null
    if(typeof v != 'boolean') return !!v
    return v
  }
  _db2v(db) {
    if(typeof(db)=='undefinded'||db===null) return null
    return db
  }

}

module.exports = BooleanField
