/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('BooleanField')

const CoreModule = require('../../core/abstract/module')
const BooleanField = require('./boolean')
const RandomBoolGenerator = require('./generators/random')
const EqTest = require('./tests/eq')
const EqSetter = require('./setters/eq')

class BooleanFieldModule extends CoreModule
{
  constructor(parent)
  {
    super(parent)
    this.M('field').registerFieldType(BooleanField)
    this.M('field').registerGenerator(RandomBoolGenerator)
    this.M('field').registerSetter(EqSetter)
    this.M('logic').registerLogicTest(EqTest)
  }

}

module.exports = BooleanFieldModule
