/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('EqTest')
let g18n = require('../../../../g18n')

const AbstractTest = require('../../../logic/abstract/test')

class EqTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'eq',
      name: g18n.t('Is'),
      iname: g18n.t('Is not'),
      invert: true,
      ops: [{
        type: 'boolean',
        name: g18n.t('comparing expression'),
        manual: true
      }],
      types: ['boolean']
    }
  }

  _test(v)
  {
    let o = this.op()
    if (typeof v!='boolean'||typeof o!='boolean')
      return false
    return v==o
  }

  queryFor(ctx,vctx)
  {
    return Rx.Observable.create(obs=>{
      let op0 = this.op()
      if (typeof op0 != 'boolean')
        return this.obsEnd(obs,null)
      let tgt = this.dataTarget().targetCode()
      let ret = {}
      ret[tgt] = op0
      if (this._conf.invert)
        ret[tgt] = !op0
      return this.obsEnd(obs,ret)
    })
  }




}

module.exports = EqTest
