/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
//let moment = require('moment')
let moment = require('moment-timezone')

let log = require('../../../../log').m('DateTimeTest')
let g18n = require('../../../../g18n')

const AbstractTest = require('../../../logic/abstract/test')

class DateTimeTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'abstd',
      name: g18n.t('Abstract datetime test'),
      iname: g18n.t('Failed'),
      ops: [],
      types: ['datetime']
    }
  }

  momentShift(mmnt,shift)
  {
    if (typeof shift!='string')
      return mmnt
    let delta = 0
    let key = ''
    shift.split(' ').forEach(op=>{
      if (op.endsWith('y')) key = 'y'
      if (op.endsWith('Q')) key = 'Q'
      if (op.endsWith('M')) key = 'M'
      if (op.endsWith('w')) key = 'w'
      if (op.endsWith('d')) key = 'd'
      if (op.endsWith('h')) key = 'h'
      if (op.endsWith('m')) key = 'm'
      if (op.endsWith('s')) key = 's'

      if (key=='') delta = parseInt(op)||0
    })
    mmnt = mmnt.add(delta,key)
    return mmnt
  }

  granFormat(gran)
  {
    if (!Array.isArray(gran)||!gran.length)
      return 'YYYY-MM-DDTHH:mm:ssZZ'
    let ret = ''
    if (gran.includes('year'))
        ret += 'YYYY'
    if (gran.includes('month'))
    {
      if (ret!='') ret+='-'
      ret += 'MM'
    }
    if (gran.includes('day'))
    {
      if (ret!='') ret+='-'
      ret += 'DD'
    }
    if (gran.includes('hour'))
    {
      if (ret!='') ret+='T'
      ret += 'HH'
    }
    if (gran.includes('minute'))
    {
      if (ret!='') ret+=':'
      ret += 'mm'
    }
    if (gran.includes('second'))
    {
      if (ret!='') ret+=':'
      ret += 'ss'
    }
    if (ret=='')
      ret = 'YYYY-MM-DDTHH:mm:ss'
    ret += 'ZZ'
    return ret
  }

  momentObj(ctx,str,granFormat=false)
  {
    if (!str||typeof str != 'string')
      return moment.invalid()
    let gran = this.fcOp(ctx,1,[])
    let fmt = this.granFormat(gran)
    if (!granFormat)
      fmt = 'YYYY-MM-DDTHH:mm:ssZZ'
    if (str.endsWith('Z'))
      fmt = 'YYYY-MM-DDTHH:mm:ss:sss'
    let ret = moment.tz(str,fmt,'')
    return ret
  }

  defGran(mmt)
  {
    if (!mmt.isValid())
      return mmt
    let conf = this.dcop(1,[])
    if (!conf.includes('year'))
      mmt.year(2001)
    if (!conf.includes('month'))
      mmt.month(1)
    if (!conf.includes('day'))
      mmt.date(1)
    if (!conf.includes('hour'))
      mmt.hour(0)
    if (!conf.includes('minute'))
      mmt.minute(0)
    if (!conf.includes('second'))
      mmt.seconds(0)
    return mmt
  }



}

module.exports = DateTimeTest
