/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../log').m('AbstractGenerator')
let g18n = require('../../g18n')

const CoreObject = require('../core/abstract/object')

class AbstractGenerator extends CoreObject
{

  constructor(parent,conf=null)
  {
    super(parent)
    this._field = this._parent
    this._node = this._field._parent
    this._conf = conf
  }

  static info()
  {
    return {
      code: 'null',
      name: g18n.t('Null generator'),
      types: ['*'],
      ops: []
    }
  }

  generate()
  {
    return Rx.Observable.create(obs=>{
      obs.next(null)
      obs.complete()
    })
  }

  generateSync()
  {
    return
  }

  confOp(opi,def)
  {
    let ret = def
    if(Array.isArray(this._conf)&&typeof this._conf[opi] != 'undefined')
      ret = this._conf[opi]
    return ret
  }


}

module.exports = AbstractGenerator

