/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('AnyAsNumberModifier<any>')
let g18n = require('../../../../g18n')

const AbstractModifier = require('../../modifier')

class AnyAsNumberModifier extends AbstractModifier
{

  static info()
  {
    return {
      code: 'asnumber',
      name: g18n.t('As number'), //getter
      iname: g18n.t('As number'), //setter
      invert: false, //cuz not invertable
      flat: true, //modifier value is single element
      strict: 'number', //keeps original field type
      ops: [{
        type: 'boolean',
        name: g18n.t('float'),
        manual: true
      },{
        type: 'number',
        name: g18n.t('digits'),
        manual: true,
        def: 2
      //},{
        //type: 'string',
        //name: g18n.t('at path'),
        //manual: true,
        //canNone: true
      }],
      types: ['any']
    }
  }

  getNext()
  {
    let nx = this._dataTarget.one()
    let ret = parseFloat(nx)
    if (!ret)
      return ret
    let isfloat = this.op(0)
    if (typeof isfloat != 'boolean')  //if not defined at all - no care
      return ret
    let digits = this.op(1,2)
    if (!isfloat)
      return Math.round(ret)
    return Math.floor( ret*Math.pow(10,digits) )/Math.pow(10,digits)
  }



}

module.exports = AnyAsNumberModifier
