/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('NumberAsBooleanModifier<any>')
let g18n = require('../../../../g18n')

const AbstractModifier = require('../../modifier')

class NumberAsBooleanModifier extends AbstractModifier
{

  static info()
  {
    return {
      code: 'asbool',
      name: g18n.t('As boolean'), //getter
      iname: g18n.t('As 1/0'),  //setter
      invert: false, //cuz not invertable
      flat: true, //modifier value is single element
      strict: 'boolean', //keeps original field type
      ops: [],
      types: ['number']
    }
  }

  getNext()
  {
    let ret = this._dataTarget.one()
    if (!!ret) return 1
    return 0
  }



}

module.exports = NumberAsBooleanModifier
