/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('NumberField')
let g18n = require('../../../g18n')

const AbstractField = require('../field')

class NumberField extends AbstractField
{

  static schema(info,schema={})
  {
    schema.type = Number
    return schema
  }

  static info()
  {
    return {
      code: 'number',
      name: g18n.t('Number'),
      conf: {
        ops: [{
          name: g18n.t('Is Real'),
          desc: g18n.t('by default all numbers are Integers'),
          type: 'boolean',
          manual: true
        },{
          name: g18n.t('Rational digits'),
          type: 'number',
          manual: true,
          def: 2
        }]
      }
    }
  }

  xtypes()
  {
    let isFloat = this.confOp(0,false)
    let type = this.constructor.info().code
    let ret = []
    if (isFloat)
      ret.push(type+':float')
    else
      ret.push(type+':integer')
    return ret
  }

  _v2db(v) {
    if(typeof v == 'undefinded'||v===null) return null
    if(typeof parseFloat(v) != 'number') return null
    return parseFloat(v)
  }
  _db2v(db) {
    if(typeof(db)=='undefinded'||db===null) return null
    return db
  }

}

module.exports = NumberField
