/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('IncSetter<number>')
let g18n = require('../../../../g18n')

const AbstractSetter = require('../../../logic/setter')

class IncSetter extends AbstractSetter
{

  static info()
  {
    return {
      code: 'inc',
      invert: false,
      name: g18n.t('Increment'),
      iname: '',
      ops: [{
        name: 'on',
        manual: true,
        type: 'number'
      }],
      types: ['number']
    }
  }

  setRange(range,target)
  {
    if (!range.length)
      return false  //can't work with arrays
    let val = parseFloat(this.op())
    range.forEach(pos=>{
      let v = target.oneModified(pos)
      //console.log(['inc',val,v,target])
      target.setModified(v+val,pos)
    })
    return true
  }



}

module.exports = IncSetter
