/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('EqTest')
let g18n = require('../../../../g18n')

const AbstractTest = require('../../../logic/abstract/test')

class EqTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'eq',
      invert: true,
      name: g18n.t('Equal'),
      iname: g18n.t('Not equal'),
      ops: [{
        type: 'number',
        name: g18n.t('to'),
        manual: true
      }],
      types: ['number']
    }
  }

  _test(v)
  {
    let v1 = parseFloat(v)
    let v2 = parseFloat(this.op())
    //log.warn('testing',[v1,v2])
    if (isNaN(v1)||isNaN(v2))
      return false
    return v1==v2
  }

  queryFor(ctx,vctx)
  {
    return Rx.Observable.create(obs=>{
      let op0 = parseFloat(this.op())
      if (isNaN(op0))
        return this.obsEnd(obs,null)
      let tgt = this.dataTarget().targetCode()
      let ret = {}
      ret[tgt] = op0
      if (this._conf.invert)
        ret = {$nor:[ret]}
      return this.obsEnd(obs,ret)
    })
  }





}

module.exports = EqTest
