/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('LengthModifier<string>')
let g18n = require('../../../../g18n')

const AbstractModifier = require('../../modifier')

class LengthModifier extends AbstractModifier
{

  static info()
  {
    return {
      code: 'length',
      name: g18n.t('Length'), //getter
      iname: g18n.t('Length'), //setter
      invert: false, //cuz not invertable
      flat: true, //modifier value is single element
      strict: 'number', //keeps original field type
      ops: [],
      types: ['string']
    }
  }

  getNext()
  {
    let ret = this._dataTarget.one()
    if (!ret||typeof ret != 'string'||!ret.length)
      return 0
    return ret.length
  }

}

module.exports = LengthModifier
