/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('ListFromStrSetter<string>')
let g18n = require('../../../../g18n')

const AbstractSetter = require('../../../logic/setter')

class ListFromStrSetter extends AbstractSetter
{

  static info()
  {
    return {
      code: 'listfromstr',
      invert: false,
      name: g18n.t('List from string'),
      iname: '', 
      ops: [{
        name: 'source',
        manual: true,
        type: 'string'
      },{
        name: 'delimeters',
        manual: true,
        type: 'string',
        value: ', ;/'
      }],
      types: ['[string]']
    }
  }

  setRange(range,target)
  {
    if (!range.length)
      return false  //can't work with arrays
    let str = this.op()
    let dels = this.op(1,',')
    let parsed = str.split( new RegExp('['+dels+']') ).map(x=>x.trim()).filter(x=>x.length)
    if (!parsed.length)
      return false
    //log.warn('setRange',[val])
    if (range[0]==-1)
    {
      //set all
      target.clear()
      parsed.forEach((p,pi)=>{
        target.setModified(p,pi)
      })
    } else {
      parsed.forEach(p=>{
        if (!range.length)
          return
        let ind = range.shift()
        target.setModified(p,ind)
      })
    }
    return true
  }

}

module.exports = ListFromStrSetter
