/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('Push2ArraySetter<string>')
let g18n = require('../../../../g18n')

const AbstractSetter = require('../../../logic/setter')

class Push2ArraySetter extends AbstractSetter
{

  static info()
  {
    return {
      code: 'push2arr',
      invert: false,
      name: g18n.t('Push element'),
      iname: '', 
      ops: [{
        name: 'value',
        manual: true,
        type: 'string'
      },{
        name: 'unique',
        manual: true,
        type: 'boolean'
      }],
      types: ['[string]']
    }
  }

  setRange(range,target)
  {
    if (!range.length)
      return false  //can't work with arrays

    let src = this.op(0,null)
    let isUnique = this.op(1,false)

    if (isUnique)
    {
      let all = target.allModified()
      if (all.includes(src))
        return false
    }

    target.setModified(src,target.size())
    return true
  }

}

module.exports = Push2ArraySetter
