/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('RemoveFromArraySetter<string>')
let g18n = require('../../../../g18n')

const AbstractSetter = require('../../../logic/setter')

class RemoveFromArraySetter extends AbstractSetter
{

  static info()
  {
    return {
      code: 'remfromarr',
      invert: false,
      name: g18n.t('Remove element'),
      iname: '', 
      ops: [{
        name: 'value',
        manual: true,
        type: 'string'
      }],
      types: ['[string]']
    }
  }

  setRange(range,target)
  {
    if (!range.length)
      return false  //can't work with arrays
    let val = this.op()

    let next = target.allModified().filter(x=>x!=val)

    target.clear()
    next.forEach((p,pi)=>{
      target.setModified(p,pi)
    })
    return true
  }

}

module.exports = RemoveFromArraySetter
