/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('InListTest')
let g18n = require('../../../../g18n')

const AbstractTest = require('../../../logic/abstract/test')

class InListTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'inlist',
      name: g18n.t('In list'),
      iname: g18n.t('Not in list'),
      invert: true,
      ops: [{
        type: '[string]',
        name: g18n.t('list'),
        manual: false
      },{
        type: 'boolean',
        name: g18n.t('/i'),
        manual: true
      }],
      types: ['string']
    }
  }

  _test(str)
  {
    let other = this.op()
    let isCI = this.op(1,false)
    if (!other||!str)
      return false
    if (!isCI)
      return str==other
    return other.toUpperCase()==str.toUpperCase()
  }

  queryFor(ctx,vctx)
  {
    return Rx.Observable.create(obs=>{
      let other = this.op(0,[],true)
      let isCI = this.op(1,false)
      let tgt = this.dataTarget().targetCode()
      let ret = {}
      if (!isCI)
      {
        ret[tgt]={$in:other}
      } else {
        ret['$or'] = other.map(x=>{
          let rr = {}
          rr[tgt] = { $regex: new RegExp('^'+x+'$','i') } 
          return rr
        })
      }
      if (this._conf.invert)
        ret = {$nor: [ret] }
      //console.log(['inlist?',other,isCI,tgt,ret])

      return this.obsEnd(obs,ret)
    })
  }



}

module.exports = InListTest
