/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('ListIncludeTest')
let g18n = require('../../../../g18n')

const AbstractTest = require('../../../logic/abstract/test')

class ListIncludeTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'inlist',
      name: g18n.t('Includes'),
      iname: g18n.t('Not includes'),
      invert: true,
      ops: [{
        type: 'string',
        name: g18n.t('to'),
        manual: true
      }],
      types: ['[string]']
    }
  }

  _test(strlist)
  {
    let other = this.op()
    if (!other||!strlist||!Array.isArray(strlist)||!strlist.length)
      return false
    return strlist.includes(other)
  }

  queryFor(ctx,vctx)
  {
    return Rx.Observable.create(obs=>{
      let other = this.op()
      let tgt = this.dataTarget().targetCode()
      let ret = {}
      ret[tgt]=other
      if (this._conf.invert)
        ret = {$nor: [ret] }
      return this.obsEnd(obs,ret)
    })
  }



}

module.exports = ListIncludeTest
