/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../../log').m('RegexpTest')
let g18n = require('../../../../g18n')

const AbstractTest = require('../../../logic/abstract/test')

class RegexpTest extends AbstractTest
{

  static info()
  {
    return {
      code: 'rx',
      name: g18n.t('RegExp test OK'),
      iname: g18n.t('RegExp test FAIL'),
      invert: true,
      ops: [{
        type: 'string',
        name: g18n.t('rx'),
        manual: true
      },{
        type: 'boolean',
        name: g18n.t('/i'),
        manual: true
      }],
      types: ['string']
    }
  }

  _test(str)
  {
    let rx = this.op()
    //log.test('testing',[str,rx])
    if (!rx||!str)
      return false
    //let rxi = this.op(1,false)
    //if (rx.startsWith('/')&&rx.endsWith('/i'))
    //{
      //rxi=true
      //rx = rx.slice(1,-2)
    //}
    let rg = null
    let keys = ''
    if (this.op(1,false))
      keys = 'i'

    try {
      rg = this.M('template').str2rx(rx,keys)
    } catch(e) {
      rg = null
    }
    if (!rg)
      return Rx.of(ret)
    let ok = false
    try {
      ok = rg.test(str)
    } catch(e) {
      ok = false
    }
 

    //if (rxi)
      //rg = new RegExp(rx,'i')
    //else
      //rg = new RegExp(rx)
    return rg.test(str)
  }

  queryFor(ctx,vctx)
  {
    return Rx.Observable.create(obs=>{
      let rx = this.op()
      if (!rx)
        return this.obsEnd(obs,null)
      let rxi = this.op(1,false)
      if (rx.startsWith('/')&&rx.endsWith('/i'))
      {
        rxi=true
        rx = rx.slice(1,-2)
      }
      let rg = null
      if (rxi)
        rg = new RegExp(rx,'i')
      else
        rg = new RegExp(rx)

      let tgt = this.dataTarget().targetCode()
      let ret = {}
      ret[tgt] = { $regex: rg }
      if (this._conf.invert)
        ret = {$nor:[ret]}
      return this.obsEnd(obs,ret)
    })
  }



}

module.exports = RegexpTest
