/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../log').m('AbstractValidator')
let g18n = require('../../g18n')

const CoreObject = require('../core/abstract/object')

class AbstractValidator extends CoreObject
{

  constructor(parent,conf=null)
  {
    super(parent)
    this._field = this._parent
    this._node = this._field._parent
    //this._core = this._field._core
    this._conf = conf
    if (!this._conf)
      this._conf = {
        invert:false
      }
  }

  static info()
  {
    return {
      code: 'nocare',
      name: g18n.t('Allways ok'),
      iname: g18n.t('Allways fail'),
      types: ['*','[]','[*]'],
      ops: []
    }
  }

  validate()
  {
    return Rx.Observable.create(obs=>{
      obs.next({valid:!this._conf.invert,error:'nocare not valid!'})
      obs.complete()
    })
  }

}

module.exports = AbstractValidator

