/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../log').m('G18NModule')
let g18n = require('./g18n')

const CoreModule = require('../core/abstract/module')
//const Conf = require('./conf')

class G18NModule extends CoreModule
{

  dashboardRoutes(app)
  {
    return Rx.Observable.create(obs=>{
      let rtAll = {
        url: '/api/translations',
        access: null,
        method: 'get',
        fn: (ctx)=>{
          return Rx.Observable.create(obs=>{
            let ret = g18n.webpack()
            this.obsEnd(obs,ret)
          })
        }
      }

      let rtT = {
        url: '/api/t',
        access: 'auth.dashboard',
        method: 'post',
        fn: (ctx)=>{
          return Rx.Observable.create(obs=>{
            let body = ctx.f('body')
            let to = body.locale || g18n.locale
            let txt = body.source || ''
            let data = body.source || null
            //console.log(ctx.view())
            let ret = g18n.t(txt,to,data)
            this.obsEnd(obs,{
              locale: to,
              source: txt,
              translation: ret
            })
          })
        }
      }

      obs.next([rtAll,rtT])
      obs.complete()
    })
  }

  t(...a)
  {
    return g18n.t(...a)
  }

}

module.exports = G18NModule
