/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('FormHttpBlock')
let g18n = require('../../../g18n')

const AbstractHttpBlock = require('./abstract')

class FormHttpBlock extends AbstractHttpBlock
{

  static info()
  {
    return {
      code: 'form',
      title: true,
      libs: false,
      confs: [{
        code: 'formcode',
        type: 'string',
        //conf:{ops:[{source:'manual',manual:['html','ace']}]},
        name: g18n.t('From code'),
        desc: g18n.t('Form code to render')
      }]
    }
  }

  test(ctx)
  {
    return Rx.of(true)
  }

  build(ctx)
  {
    return Rx.Observable.create(obs=>{
      let ret = {
        id: this.id(),
        types: ['block',this.f('type')],
        title: null,
        content: null
      }
      let data = this.f('data')
      let fcode = data.formcode
      let fc = ctx.vnode('router')._fc()
      //console.log(this.toObject())
      fc.findNode({code:data.formcode}).pipe(
        RxO.mergeMap(f=>{
          ret.content = {
            url: '',
            fid: f.id(),
            fields: []
          }
          let furl = f.f('url')
          if (!furl||!furl.length||furl=='*')
            furl = ctx.vnode('http').f('url')
          if (!furl.startsWith('/'))
            furl = '/'+furl
          ret.content.url = furl
          //console.log(f)
          return f.build()
        })
      ).subscribe(form=>{
        //console.log(['form',form])
        ret.content.fields = form
        this.obsEnd(obs,ret)
      },err=>this.obsErr(obs,err))
        //Rx.forkJoin(
          //this.M('template').liquify(this.f('title'),ctx.view()),
        //this.M('template').liquify(this.f('data').content,ctx.view())
        //.subscribe(bld=>{
          //ret.title = null
          //ret.content = bld
        //},err=>this.obsErr(obs,err))
      //})
 

    })
  }


}

module.exports = FormHttpBlock
