/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('LibraryHttpBlock')
let g18n = require('../../../g18n')

const AbstractHttpBlock = require('./abstract')

class LibraryHttpBlock extends AbstractHttpBlock
{

  static info()
  {
    return {
      code: 'library',
      title: true,
      libs: true,
      confs: [{
        code: 'content',
        type: 'string',
        conf:{ops:[{source:'manual',manual:['html','ace']}]},
        name: g18n.t('Block html result')
      }]
    }
  }

  build(ctx)
  {
    return Rx.Observable.create(obs=>{
      let ret = {
        id: this.id(),
        types: ['block',this.f('type')],
        title: null,
        content: null
      }
      let data = this.f('data')
      if (!data.libs)
        data.libs = []
      let $t = data.libs.map(l=>this.M('logic').library(ctx,l))
      Rx.concat(...$t).subscribe(_=>{},err=>this.obsErr(obs,err),_=>{
        Rx.forkJoin(
          this.M('template').liquify(this.f('title'),ctx.view()),
          this.M('template').liquify(this.f('data').content,ctx.view()),
        ).subscribe(bld=>{
          ret.title = bld[0]=='<none>'?null:bld[0]
          ret.content = bld[1]
          this.obsEnd(obs,ret)
        },err=>this.obsErr(obs,err))
      })
 

    })
  }


}

module.exports = LibraryHttpBlock
