/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('TextHttpBlock')
let g18n = require('../../../g18n')

const AbstractHttpBlock = require('./abstract')

class TextHttpBlock extends AbstractHttpBlock
{

  static info()
  {
    return {
      code: 'text',
      title: true,
      libs: false,
      confs: [{
        code: 'content',
        type: 'string',
        conf:{ops:[{source:'manual',manual:['html','ace']}]},
        name: g18n.t('Block html result')
      }]
    }
  }

  build(ctx)
  {
    return Rx.forkJoin(
      this.M('template').liquify(this.f('title'),ctx.view()),
      this.M('template').liquify(this.f('data').content,ctx.view()),
    ).pipe(RxO.map(bld=>{
      return {
        id: this.id(),
        types: ['block',this.f('type')],
        title: bld[0]=='<none>'?null:bld[0],
        content: bld[1]
      }
    }))
  }


}

module.exports = TextHttpBlock
