/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('VueHttpBlock')
let g18n = require('../../../g18n')

const AbstractHttpBlock = require('./abstract')

class VueHttpBlock extends AbstractHttpBlock
{

  static info()
  {
    return {
      code: 'vue',
      title: false,
      libs: true,
      confs: [{
        code: 'content',
        type: 'string',
        conf:{ops:[{source:'manual',manual:['html','ace']}]},
        name: g18n.t('Block VUE html result'),
        desc: g18n.t('Block result as vue html code. Liquid supported')
      }]
    }
  }

  test(ctx)
  {
    return Rx.of(true)
  }

  build(ctx)
  {
    return Rx.Observable.create(obs=>{
      let ret = {
        id: this.id(),
        types: ['block',this.f('type')],
        title: null,
        content: null
      }
      let data = this.f('data')
      if (!data.libs)
        data.libs = []
      let $t = data.libs.map(l=>this.M('logic').library(ctx,l))
      Rx.concat(...$t).subscribe(_=>{},err=>this.obsErr(obs,err),_=>{
        //Rx.forkJoin(
          //this.M('template').liquify(this.f('title'),ctx.view()),
        this.M('template').liquify(this.f('data').content,ctx.view())
        .subscribe(bld=>{
          ret.title = null
          ret.content = bld
          this.obsEnd(obs,ret)
        },err=>this.obsErr(obs,err))
      })
 

    })
  }


}

module.exports = VueHttpBlock
