/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let fs = require('fs')
let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('RedirectHttpRenderer')
let g18n = require('../../../g18n')

const pug = require('pug')

const AbstractHttpRenderer = require('./renderer')

class RedirectRenderer extends AbstractHttpRenderer
{

  static info()
  {
    return {
      code: 'redirect',
      name: g18n.t('Redirect renderer'),
      desc: g18n.t('Http reply javascript vue component')
    }
  }

  render(ctx)
  {
    return Rx.of(ctx.vnode('page')).pipe(
      RxO.mergeMap(page=>{
        let data = page.variant().data
        let url = data.url
        log.warn('redirecting to',url)
        return Rx.of({
          redirect: url
        })
      })
    )
  }


}

module.exports = RedirectRenderer
