/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let fs = require('fs')
let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('AbstractHttpRenderer')
let g18n = require('../../../g18n')

const CoreObject = require('../../core/abstract/object')

class AbstractHttpRenderer extends CoreObject
{

  static info()
  {
    return {
      code: 'abstract',
      name: g18n.t('Abstract http renderer'),
      desc: g18n.t('Used as interface for other renderers only')
    }
  }

  init(ctx)
  {
    return Rx.of(true)
  }

  render(ctx)
  {
    return Rx.throwError({code:'ABSTRACT_HTTP_RENDERER_RENDER'})
  }


}

module.exports = AbstractHttpRenderer
