/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let fs = require('fs')
let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('VueHttpRenderer')
let g18n = require('../../../g18n')

const pug = require('pug')

const AbstractHttpRenderer = require('./renderer')

class VueRenderer extends AbstractHttpRenderer
{

  static info()
  {
    return {
      code: 'vuec',
      name: g18n.t('Vue renderer'),
      desc: g18n.t('Http reply javascript vue component')
    }
  }

  render(ctx)
  {
    return Rx.of(ctx.vnode('page')).pipe(
      RxO.mergeMap(page=>{
        let data = page.variant().data
        let dtpl = data.template || ''
        let djs = data.js || ''
        //console.log(['vue compile',dtpl,djs])
        return this.M('template').liquify(djs,ctx.view()).pipe(RxO.map(js=>{
          if (dtpl&&dtpl.length)
            dtpl = dtpl.trim()
          if (dtpl&&dtpl.length)
            dtpl = dtpl.replace(/\n/g,'')
          let jss = js.slice(0,-1)+',template: `'+dtpl+'`\n}'
          //console.log(['vue return',jss])
          return {
            js: jss
          }
        }))
      })
    )
  }


}

module.exports = VueRenderer
