/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('WebsiteMenuModule')
let g18n = require('../../../g18n')

const CoreModule = require('../../core/abstract/module')
const VNode = require('../../node/vnode')

class WebsiteMenuModule extends CoreModule
{

  constructor(parent)
  {
    super(parent)
  }

  moduleUpdate(from,to)
  {
    return Rx.of(to)
  }

  /*
  moduleInstall()
  {
    return Rx.Observable.create(obs=>{
      let $t = []

      //blocks data bundle
      let bndBlocks = this.M('bundle').bundle('menus',true)
      bndBlocks.name(g18n.t('Web Menus'))
      bndBlocks.desc(g18n.t('Web sites menus'))
      bndBlocks.addFlag('system')
      bndBlocks.addField({name:g18n.t('Enabled'),code:'enabled',type:'boolean',flags:['system','logic','title','template'],def:true})
      bndBlocks.addField({name:g18n.t('Code'),code:'code',type:'string',flags:['system','required','unique','template','logic']})
      bndBlocks.addField({name:g18n.t('Name'),code:'name',type:'string',flags:['system','required','template','logic']})
      bndBlocks.addField({name:g18n.t('Type'),code:'type',type:'string',flags:['system','required','template','logic']})
      bndBlocks.addField({name:g18n.t('Flags'),code:'flags',type:'string',flags:['system','template','logic'],quantity:0})
      bndBlocks.addField({name:g18n.t('Logic'),code:'logic',type:'any',flags:['system','logic','template'],def:null})
      bndBlocks.addField({name:g18n.t('Title'),code:'title',type:'string',flags:['system','template','logic']})
      bndBlocks.addField({name:g18n.t('Data'),code:'data',type:'any',flags:['system','template','logic']})

      log.log('installing bundle',bndBlocks.code())
      $t.push(bndBlocks.save(true,true))

      Rx.concat(...$t).subscribe(()=>{},obs.error,()=>{
        log.success('bundle installed')
        this.obsEnd(obs)
      })
 
    })
  }
  /**/


}

module.exports = WebsiteMenuModule
