/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('ContentPage')
let g18n = require('../../../g18n')

const AbstractHttpPage = require('./page')

class ContentPage extends AbstractHttpPage
{

  buildContentBlock(ctx)
  {
    return Rx.Observable.create(obs=>{
      let content = ctx.vnode('content')
      let obj = null
      let cid = ''
      let bnd = ''
      if (content)
      {
        obj = content.toObject()
        cid = content.id()
        bnd = content.bundle()
      }
      let pg = this.variant().data
      //let pg = this.f('data')
      //log.warn('build content block')
      //console.log(pg,content.view('content'))
      this.M('template').liquify(pg.content,ctx.view()).subscribe(html=>{
        //console.log(['contentHtml',html])
        this.obsEnd(obs,{
          id: cid,
          types: ['content',bnd],
          content: html,
          title: null
        })
      })
    })
  }

  compile(ctx)
  {
    return Rx.Observable.create(obs=>{
      let content = ctx.vnode('content')
      this.obsEnd(obs,{
        content:content
      })
    })
  }

}

module.exports = ContentPage
