/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('HTTPRoute')
let g18n = require('../../../g18n')

const Node = require('../../node/node')

class HTTPRoute extends Node
{

  constructor(parent,model,isNew=false)
  {
    super(parent,model,isNew)
    this._type = 'httproute'
    this._ctx = null
  }

  prepare(ctx)
  {
    return Rx.Observable.create(obs=>{
      this._ctx = ctx
      ctx.addNode(this,'route')
      let tbundle = this.f('target')
      if (!tbundle||!this.C(tbundle))
        return this.obsErr({code:'ROUTE_TARGET_NOT_FOUND'})
      this.C(tbundle).findId(this.f('nid')).subscribe(tNode=>{
        ctx.addNode(tNode,'content')
        this.obsEnd(obs,this)
      },err=>{
        this.obsErr({code:'ROUTE_NODE_SEARCH_ERROR'})
      })
    })
  }

  execute(http)
  {
    return Rx.Observable.create(obs=>{
      console.log(['route execute',this._model])
      //this.C('http_routes').setNodeClass(HTTPRoute)
      this.obsEnd(obs,this)
    })
  }


}

module.exports = HTTPRoute
