/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('HttpRouteField')
let g18n = require('../../../g18n')

const AbstractField = require('../../field/field')

class HttpRouteField extends AbstractField
{
  static schema(info,sch={}) {
    sch.type = String
    return sch
  }

  static info()
  {
    return {
      code: 'httproute',
      name: g18n.t('Http route (url)'),
      conf: { ops:[{
        type: 'string',
        code: 'router',
        name: g18n.t('HTTP Router code')
      }] }
    }
  }

  xtypes()
  {
    return this.constructor.info().code
  }

  _v2db(v) {
    if(typeof v == 'undefined'||v===null) return null
    if(typeof v != 'string') return v.toString()
    return v
  }

  _db2v(db) {
    return db
  }

}

module.exports = HttpRouteField
