/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../log').m('AbstractRouter')
let g18n = require('../../g18n')

const Node = require('../node/node')

const AbstractRoute = require('./route')

class AbstractRouter extends Node
{

  static info()
  {
    return {
      code: 'abstract',
      name: g18n.t('Abstract router'),
      desc: g18n.t('Abstract router description'),
      scope: 'abstract',
      confs: []
    }
  }

  checkInstall()
  {
    return Rx.of(true)
  }

  install()
  {
    log.info('abstract router installation')
    return Rx.of(true)
  }

  uninstall()
  {
    log.info('abstract router uninstallation')
    return Rx.of(true)
  }

 
  //common routines
  searchRoute(ctx)
  {
    return Rx.of(new AbstractRoute(this))
  }

}

module.exports = AbstractRouter
