/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


const chalk = require('chalk')

let moment = require('moment')

class ConsoleLog
{

  constructor(rxlog)
  {
    this._rxlog = rxlog
    this._locale = 'en'
    this._format = 'DD/MM/YYYY HH:mm:ss:SSS'
    this.outs = {
      log: true,
      info: true,
      test: true,
      warn: true,
      err: true,
      success: true
    }
    rxlog.on.log.subscribe(vars=>{ this._log(vars) })
    rxlog.on.info.subscribe(vars=>{ this._info(vars) })
    rxlog.on.test.subscribe(vars=>{ this._test(vars) })
    rxlog.on.warn.subscribe(vars=>{ this._warn(vars) })
    rxlog.on.err.subscribe(vars=>{ this._err(vars) })
    rxlog.on.success.subscribe(vars=>{ this._success(vars) })
  }

  _log(vars)
  {
    //setTimeout(()=>{
      if(!this.outs.log) return
      let str = chalk.white(moment().format(this._format))+' ['+chalk.blue(vars.key)+'] '+chalk.dim(vars.msg)
      if (vars.obj) str += ' <'+JSON.stringify(vars.obj)+'>'
      console.log(str)
    //},0)
  }

  _pid()
  {
    return ''
  }

  _info(vars)
  {
    if(!this.outs.info) return
    let str = chalk.white(moment().format(this._format))+' ['+chalk.cyan(vars.key)+'] '+chalk.dim(vars.msg)
    if (vars.obj) str += ' <'+JSON.stringify(vars.obj)+'>'
    console.log(this._pid()+str)
  }

  _test(vars)
  {
    if(!this.outs.test) return
    let str = chalk.white(moment().format(this._format))+' ['+chalk.magenta(vars.key)+'] '+chalk.dim(vars.msg)
    if (vars.obj) str += ' <'+JSON.stringify(vars.obj)+'>'
    console.log(this._pid()+str)
  }

  _warn(vars)
  {
    if(!this.outs.warn) return
    let str = chalk.white(moment().format(this._format))+' ['+chalk.yellow(vars.key)+'] '+chalk.dim(vars.msg)
    if (vars.obj) str += ' <'+JSON.stringify(vars.obj)+'>'
    console.log(this._pid()+str)
  }

  _err(vars)
  {
    if(!this.outs.err) return
    let str = chalk.white(moment().format(this._format))+' ['+chalk.red(vars.key)+'] '+chalk.dim(vars.msg)
    if (vars.obj) str += ' <'+JSON.stringify(vars.obj)+'>'
    console.log(this._pid()+str)
  }

  _success(vars)
  {
    if(!this.outs.success) return
    let str = chalk.white(moment().format(this._format))+' ['+chalk.green(vars.key)+'] '+chalk.dim(vars.msg)
    if (vars.obj) str += ' <'+JSON.stringify(vars.obj)+'>'
    console.log(this._pid()+str)
  }

}

module.exports = ConsoleLog
