/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


const Rx = require('rxjs')

class Log
{

  constructor()
  {
    this.on = {}
    this.on.log = new Rx.Subject()
    this.on.info = new Rx.Subject()
    this.on.test = new Rx.Subject()
    this.on.warn = new Rx.Subject()
    this.on.err = new Rx.Subject()
    this.on.success = new Rx.Subject()
  }

  m(m)
  {
    let ret = {
      l: this,
      log: (...a)=>{ this.log(m,...a) },
      info: (...a)=>{ this.info(m,...a) },
      test: (...a)=>{ this.test(m,...a) },
      warn: (...a)=>{ this.warn(m,...a) },
      err: (...a)=>{ this.err(m,...a) },
      success: (...a)=>{ this.success(m,...a) }
    }
    return ret
  }

  vars(defKey,key,msg=null,obj=null)
  {
    let ret = {
      key: defKey,
      msg: '',
      obj: null
    }
    if (!msg) {
      ret.msg = key 
    } else {
      if (typeof msg != 'string')
      {
        ret.msg = key
        ret.obj = msg
      } else {
        if (msg)
        {
          ret.key = key
          ret.msg = msg
        }  else {
          ret.msg = key
        }
        if (obj)
          ret.obj = obj
      }
    }
    return ret
  }

  log(key,msg=null,obj=null)
  {
    let vars = this.vars('..',key,msg,obj)
    this.on.log.next(vars)
  }

  info(key,msg=null,obj=null)
  {
    let vars = this.vars('..',key,msg,obj)
    this.on.info.next(vars)
  }

  test(key,msg=null,obj=null)
  {
    let vars = this.vars('??',key,msg,obj)
    this.on.test.next(vars)
  }

  warn(key,msg=null,obj=null)
  {
    let vars = this.vars('!!',key,msg,obj)
    this.on.warn.next(vars)
  }

  err(key,msg=null,obj=null)
  {
    let vars = this.vars('!!',key,msg,obj)
    this.on.err.next(vars)
  }

  success(key,msg=null,obj=null)
  {
    let vars = this.vars('ok',key,msg,obj)
    this.on.success.next(vars)
  }

}

module.exports = Log
