/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../log').m('LogModule')
let g18n = require('../../g18n')

const CoreModule = require('../core/abstract/module')

class LogModule extends CoreModule
{

  moduleConfigure(cfg)
  {
    this._config = cfg
    log.l.setOuts(cfg)
    return Rx.of(null)
  }

  moduleInstall()
  {
    return Rx.of({
      log:false,
      warn: true,
      test: true,
      success: true,
      err: true,
      info: true
    })
  }

}

module.exports = LogModule
