/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../../log').m('AbstractTest')
let g18n = require('../../../g18n')

const AbstractExecutor = require('./executor')

class AbstractTest extends AbstractExecutor
{

  static info()
  {
    return {
      code: 'abstract',
      name: 'Abstract logic test',
      iname: 'Inverted name',
      ops: [], //0 additional operators
      types: ['*','[]'], //list of types, test can be applyed
      scope: 'any' //test scope - context/db/any, default or none = any
    }
  }

  //should be reimplemented
  _test(data,ctx)
  {
    log.err('abstract test always fail')
    return false
  }

  test(ctx,dataTarget)
  {
    return Rx.Observable.create(obs=>{
      let fin = false
      let inf = this.constructor.info()
      dataTarget.data().subscribe(v=>{
        let tr = this._test(v,ctx)
        if (!!this._conf.invert)
          tr = !tr
        //log.warn('tested',[v,inf.code,this.op(),tr,fin])
        //CALLBACK?? WTF???
        //dirty hack to "return data and set variable before function return"
        dataTarget.accumulate(tr,ar=>{
          fin = ar
        })
      },err=>{
        log.err('abstract test err')
        console.log(err)
        this.obsEnd(obs,!!this._conf.invert)
      },()=>{
        //log.warn('abstract test result',[inf.code,this.op(),fin])
        //let ret = !!this._conf.invert?!fin:fin
        this.obsEnd(obs,fin)
      })
    })
  }

}

module.exports = AbstractTest
