/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('AbstractTestable')
let g18n = require('../../../g18n')

const CoreObject = require('../../core/abstract/object')
const Node = require('../../node/node')

class TestableObject extends CoreObject
{

  constructor(parent)
  {
    super(parent)
    this._logicScope = ''
  }

  logicScope(nx)
  {
    if (typeof nx=='string'&&nx!='')
      this._logicScope = nx
    return this._logicScope
  }

  logicFields(ret=[])
  {
    return ret
  }

  _fields2view(fields,scoped=false)
  {
    let view = {}
    let rscope = null
    fields.forEach(f=>{
      let scope = f.scope
      if (!rscope)
        rscope = scope
      if (!view[scope])
        view[scope] = {}
      let fi = f.info
      if (fi.quantity==1)
      {
        if (f.subs&&f.subs.length)
        {
          view[scope][fi.code] = this._fields2view(f.subs[0],true)
        } else {
          let vv = f.values[0]
          if (typeof vv == 'object' && vv instanceof TestableObject)
            view[scope][fi.code] = vv.toObject()
          else
            view[scope][fi.code] = vv
        }
      } else {
        view[scope][fi.code] = []
        if (f.subs&&f.subs.length)
        {
          f.subs.forEach(sb=>{
            view[scope][fi.code].push(this._fields2view(sb,true))
          })
        } else {
          let vv = f.values.map(x=>{
            if (typeof x == 'object' && x instanceof TestableObject)
              return x.toObject()
            return x
          })
          view[scope][fi.code] = vv
        }
      }
    })
    if (scoped)
      return view[rscope]
    return view
  }

  view(scoped=false)
  {
    return this._fields2view(this.logicFields(),scoped)
  }

  toObject()
  {
    return this.view(true)
  }


}

module.exports = TestableObject
