/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../log').m('Logic')
let g18n = require('../../g18n')

const CoreObject = require('../core/abstract/object')
//let FieldTypes = require('../models/UserField')

class Logic extends CoreObject
{

  constructor(parent)
  {
    super(parent)
  }

  /*
  async test(user,screen,cmd,cron,msgi=-1)
  {
    let logic = screen.logic
    if(!logic)
      return true
    let cmdFields = cmd? cmd.fields() : []
    let userFields = user.params
    let manFields = await FieldTypes.find({behavior:'user'})
    let screenFields = this.screenFields(screen)
    //console.log(cron)
    let cronFields = this.cronFields(cron)
    let fields = []
    for(let i=0;i<cmdFields.length;i++)
      fields.push(cmdFields[i])
    for(let i=0;i<userFields.length;i++)
      fields.push(userFields[i])
    fields.push({
      code: 'user:locale', typeCode: 'user:locale',
      type: {type:'string',code:'user:locale',behavior:'screen'},
      vall: user.locale
    })
    for(let i=0;i<manFields.length;i++)
      fields.push(manFields[i])
    for(let i=0;i<screenFields.length;i++)
      fields.push(screenFields[i])
    for(let i=0;i<cronFields.length;i++)
      fields.push(cronFields[i])

    if (msgi!=-1)
    {
      log.log('LOGIC!','Message logic testing!')
      logic = screen.messages[msgi].logic
      let msgFields = this.logicFields(logic)
      for(let i=0;i<msgFields.length;i++)
        fields.push(msgFields[i])
    }
    let fKeys = []
    for(let i=0;i<fields.length;i++)
      fKeys.push({c:fields[i].code,v:fields[i].vall})
    log.log('LOGIC!','Start testing screen',screen)
    log.log('LOGIC!','Start testing with fields',fKeys)
    log.log('LOGIC!','Start testing logic',{logic:logic})
    if(!logic)
      return true
    return this.testLogicGroup(user,logic.conditions,fields)
  }

  isEmptyLogicGroup(group)
  {
    if(!group)
      return true
    if((!group.f||!group.f.length)&&(!group.g||!group.g.length))
      return true
    return false
  }

  /**
  testLogicGroup(user,group,fields)
  {
    if (this.isEmptyLogicGroup(group))
      return true
    let ret = true
    if (group.op=='or')
      ret = false
    let done = false
    for(let i=0;i<group.g.length;i++)
    {
      let subTest = this.testLogicGroup(user,group.g[i],fields)
      if (subTest && group.op=='or')
      {
        ret = true
        done = true
        break
      }
      if (!subTest && group.op=='and')
      {
        ret = false
        done = true
        break
      }
    }
    if (done)
      return ret
    for(let i=0;i<group.f.length;i++)
    {
      let subTest = this.testLogicCondition(user,group.f[i],fields)
      if (subTest && group.op=='or')
      {
        ret = true
        break
      }
      if (!subTest && group.op=='and')
      {
        ret = false
        break
      }
    }
    return ret
  }

  _f(code,fields)
  {
    for(let i=0;i<fields.length;i++)
      if (fields[i].code==code)
        return fields[i]
    return
  }

  /**
  testLogicCondition(user,cond,fields)
  {
    log.log('LOGIC','Testing condition',{test:cond,userfields:user.params,data:fields})
    let op = cond.opobj
    let opA =  this._f(cond.opa,fields)
    //we have some operators on single field
    if(cond.op=='isnull')
      return this._isnull(opA,cond.invert)
    //other test requires opA
    if (!opA)
    {
      log.err('LOGIC','Operator A for test not found!',cond)
      return false
    }
    if(cond.op=='uhf')
      return this._uhf(user,opA,cond.invert)


    //next tests requires opB
    let opB = this._f(cond.opb,fields)
    if (cond.opb=='man')
      opB = { vall: cond.valb }
    if (!opB||typeof(opB)=='undefined')
    {
      log.err('LOGIC','Operator B for test not found!',cond)
      return false
    }
    log.log('LOGIC','Testing',{op:op,a:opA,b:opB})
    if(cond.op=='eq')
      return this._eq(opA,opB,cond.invert)
    if(cond.op=='lt')
      return this._lt(opA,opB,cond.invert)
    if(cond.op=='lte')
      return this._lte(opA,opB,cond.invert)
    if(cond.op=='contains') //string
      return this._contains(opA,opB,cond.invert)
    if(cond.op=='rx') //string
      return this._rx(opA,opB,cond.invert)

    //next tests require opC
    let opC = this._f(cond.opb,fields)
    if (cond.opc=='man')
      opC = { vall: cond.valc }
    if (!opC||typeof(opC)=='undefined')
    {
      log.err('LOGIC','Operator C for test not found!',cond)
      return false
    }

    if(cond.op=='diffeq')
      return this._diffeq(opA,opB,opC,cond.invert)
    if(cond.op=='difflt')
      return this._difflt(opA,opB,opC,cond.invert)
    if(cond.op=='difflte')
      return this._difflte(opA,opB,opC,cond.invert)

    if(cond.op=='sumeq')
      return this._sumeq(opA,opB,opC,cond.invert)
    if(cond.op=='sumlt')
      return this._sumlt(opA,opB,opC,cond.invert)
    if(cond.op=='sumlte')
      return this._sumlte(opA,opB,opC,cond.invert)

    if(cond.op=='muleq')
      return this._muleq(opA,opB,opC,cond.invert)
    if(cond.op=='mullt')
      return this._mullt(opA,opB,opC,cond.invert)
    if(cond.op=='mullte')
      return this._mullte(opA,opB,opC,cond.invert)

    if(cond.op=='diveq')
      return this._diveq(opA,opB,opC,cond.invert)
    if(cond.op=='divlt')
      return this._divlt(opA,opB,opC,cond.invert)
    if(cond.op=='divlte')
      return this._divlte(opA,opB,opC,cond.invert)

    return true
  }

  //   TESTS

  /**
  _isnull(op,inv=false)
  {
    if(typeof op == 'undefined')
      return false
    if(typeof op.vall == 'undefined')
      return inv ? false : true
    if(op.vall===''||op.vall===null)
      return inv ? false : true
    return inv
  }

  _uhf(user,op,inv=false)
  {
    let has = false
    for(let i=0;i<user.params.length;i++)
      if(user.params[i].code==op.code)
        has = true
    return inv ? !has : has
  }

  _eq(opA,opB,inv=false)
  {
    let eq = opA.vall==opB.vall
    return inv ? !eq : eq
  }

  //strings test
  _rx(opA,opB,inv=false){
    let sa = opA.vall+''
    let sb = opB.vall+''
    let rx = null
    let rxi = false
    if (sb.startsWith('/')&&sb.endsWith('/i'))
    {
      rxi=true
      sb=sb.slice(1,-2)
    }
    if (rxi)
      rx = new RegExp(sb,'i')
    else
      rx = new RegExp(sb)
    let rs = rx.test(sa)
    return inv?!rs:rs
  }

  _contains(opA,opB,inv=false){
    let sa = opA.vall+''
    let sb = opB.vall+''
    let rs = sa.indexOf(sb)!=-1 ?true:false
    //console.log('====================================')
    //console.log(['contains test',{a:sa,b:sb,res:rs}])
    //console.log('====================================')
    return inv?!rs:rs
  }

  //numbers test
  _lt(opA,opB,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let r = a < b
    return inv ? !r : r
  }
  _lte(opA,opB,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let r = a <= b
    return inv ? !r : r
  }
  _diffeq(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a-b==c)
    return inv ? !r : r
  }
  _difflt(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a-b<c)
    return inv ? !r : r
  }
  _difflte(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a-b<=c)
    return inv ? !r : r
  }
  _summeq(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a+b==c)
    return inv ? !r : r
  }
  _summlt(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a+b<c)
    return inv ? !r : r
  }
  _summlte(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a+b<=c)
    return inv ? !r : r
  }
  _muleq(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a*b==c)
    return inv ? !r : r
  }
  _multl(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a*b<c)
    return inv ? !r : r
  }
  _mullte(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a*b<=c)
    return inv ? !r : r
  }
  _diveq(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a/b==c)
    return inv ? !r : r
  }
  _divlt(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a/b<c)
    return inv ? !r : r
  }
  _divlte(opA,opB,opC,inv=false){
    let a = parseFloat(opA.vall)
    let b = parseFloat(opB.vall)
    let c = parseFloat(opC.vall)
    let r = (a/b<=c)
    return inv ? !r : r
  }

  //datetime
  //_isfuture
  //_ispast

  // some helpers
  /**
  screenFields(screen,ret=[])
  {
    if (!screen) return ret
    ret.push({
      code: 'screen:command', typeCode: 'screen:command',
      type: {type:'string',code:'screen:command',behavior:'screen'},
      vall: screen.command
    })
    ret.push({
      code: 'screen:key', typeCode: 'screen:key',
      type: {type:'string',code:'screen:key',behavior:'screen'},
      vall: screen.key
    })
    return this.logicFields(screen.logic,ret)
  }

  /**
  cronFields(cron,ret=[])
  {
    if (!cron) return ret
    ret.push({
      code: 'cron:second', typeCode: 'cron:second',
      type: {type:'number',code:'cron:second',behavior:'screen'},
      vall: cron.sec
    })
    ret.push({
      code: 'cron:minute', typeCode: 'cron:minute',
      type: {type:'number',code:'cron:minute',behavior:'screen'},
      vall: cron.min
    })
    ret.push({
      code: 'cron:hour', typeCode: 'cron:hour',
      type: {type:'number',code:'cron:hour',behavior:'screen'},
      vall: cron.hrs
    })
    ret.push({
      code: 'cron:dayofmonth', typeCode: 'cron:dayofmonth',
      type: {type:'number',code:'cron:dayofmonth',behavior:'screen'},
      vall: cron.day
    })
    ret.push({
      code: 'cron:month', typeCode: 'cron:month',
      type: {type:'number',code:'cron:month',behavior:'screen'},
      vall: cron.mon
    })
    ret.push({
      code: 'cron:dayofweek', typeCode: 'cron:dayofweek',
      type: {type:'number',code:'cron:dayofweek',behavior:'screen'},
      vall: cron.dow
    })
    return ret
  }

  /**
  logicFields(logic,ret=[])
  {
    if(!logic)
      return ret
    if(!logic.fields||!logic.fields.length)
      return ret
    for(let i=0;i<logic.fields.length;i++)
      ret.push(logic.fields[i])
    return ret
  }
  /**/
}

module.exports = Logic
