/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../log').m('AbstractSetter')
let g18n = require('../../g18n')

const AbstractExecutor = require('./abstract/executor')

class AbstractSetter extends AbstractExecutor
{

  static info()
  {
    return {
      code: 'abstract',
      name: g18n.t('Abstract setter'),
      types: ['**'],
      ops: []
    }
  }

  //shouldBeReimplemented
  setRange(range,target)
  {
    log.err('abstract setter always fail')
    return false
  }

  setter(ctx,dataTarget)
  {
    return Rx.Observable.create(obs=>{
      let fin = false
      let inf = this.constructor.info()
      let range = dataTarget.setRange()
      if (!Array.isArray(range))
        return this.obsEnd(obs,false)
      let changed = this.setRange(range,dataTarget)
      if (!changed)
        return this.obsErr(obs,{code:'SET_FAILED'})
      dataTarget.saveModified().subscribe(()=>{
        this.obsEnd(obs,true)
      },err=>{
        log.err('target save error!')
        console.log(err)
        this.obsEnd(obs,false)
      })
    })
  }

}

module.exports = AbstractSetter
