/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxOps = require('rxjs/operators')

let log = require('../../log').m('TelegramBotQueue')
let g18n = require('../../g18n')

const CoreObject = require('../core/abstract/object')
const ChatQueue = require('./chatQueue')

class BotQueue extends CoreObject
{
  constructor(parent)
  {
    super(parent)
    this._run = false
    this.q = []
    this._chats = {}

    this._obs = null
    this.next = Rx.Observable.create(obs=>{
      this._obs = obs
    })

    setInterval(()=>{
      if (this._run)
        this.emit()
    },50)
  }

  bot() { return this._parent }
  run(next)
  {
    if (typeof next == 'boolean')
      this._run = next
    return this._run
  }

  push($msg)
  {
    //console.log('message2BotQueue',$msg)
    let $chat = $msg.fp('chat')
    let cid = $chat.f('chatId')
    if (!this._chats[cid])
    {
      let conf = $chat.f('conf')
      let delay = conf&&conf['answer:delay']?parseFloat(conf['answer:delay']):0
      if ($chat.f('type')!='private'&&delay<3)
        delay = 3
      if ($chat.f('type')=='private'&&delay<1)
        delay = 1

      let q = new ChatQueue(this,delay*1000)
      q.next.subscribe($msg=>{
        this.q.push($msg)
      })
      this._chats[cid] = q
    }
    this._chats[cid].push($msg)
  }

  emit()
  {
    if (!this._run) return
    if (!this.q.length) return
    this._obs.next(this.q.shift())
  }
}

module.exports = BotQueue
