/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../log').m('TelegramChatQueue')
let g18n = require('../../g18n')

const CoreObject = require('../core/abstract/object')

class ChatQueue extends CoreObject
{
  constructor(parent,interval=1000)
  {
    super(parent)

    this._interval = interval
    this._last = 0
    this._wait = false

    this.pq = {}
    for(let i=0;i<10;i++)
      this.pq[i] = []

    this._obs = null
    this.next = Rx.Observable.create(obs=>{
      this._obs = obs
    })
  }

  push($msg)
  {
    let prio = $msg.priority()
    let $chat = $msg.fp('chat')
    if (!prio)
      prio = $chat.f('priority')
    if (!prio&&$chat.f('type')!='private')
      prio = 6
    if (!prio&&$chat.f('type')=='private')
      prio = 4
    if (prio<0||prio>9)
      prio = 5
    this.pq[prio].push($msg)
    this.checkNext()
  }

  checkNext(pass=false)
  {
    let prio = -1
    for(let i=0;i<10;i++)
    {
      if (!this.pq[i].length) continue
      prio = i
      break
    }
    if (prio==-1) return
    if (this._wait&&!pass) return
    this._wait = true
    let d = new Date()
    let t = d.getTime()
    let diff = t - this._last
    if (diff<this._interval)
    {
      setTimeout(()=>{
        this.checkNext(true)
      },diff)
      return
    }
    let m = this.pq[prio].shift()
    m.onSended.pipe(
      RxO.mergeMap(x=>m.saveToChatHistory())
    ).subscribe(res=>{
      let d = new Date()
      this._last = d.getTime()
      this._wait = false
      this.checkNext()
    })
    this._obs.next(m)
  }

}

module.exports = ChatQueue
