/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('IsBotGenerator')
let g18n = require('../../../g18n')

const AbstractGenerator = require('../../field/generator')

class IsBotGenerator extends AbstractGenerator
{

  static info()
  {
    return {
      code: 'tg:isBot',
      name: g18n.t('Telegram profile is bot'),
      types: ['boolean'],
      ops: []
    }
  }

  generate(ctx=null)
  {
    return Rx.Observable.create(obs=>{
      let val = null
      //console.log(['generator isBot',ctx])
      if(ctx&&ctx.tg&&typeof(ctx.tg.is_bot)!='undefined')
        val = ctx.tg.is_bot
      obs.next(val)
      obs.complete()
    })
  }

}

module.exports = IsBotGenerator

