/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')

let log = require('../../../log').m('LastNameGenerator')
let g18n = require('../../../g18n')

const AbstractGenerator = require('../../field/generator')

class LastNameGenerator extends AbstractGenerator
{

  static info()
  {
    return {
      code: 'tg:lastName',
      name: g18n.t('Telegram profile last name'),
      types: ['string'],
      ops: []
    }
  }

  generate(ctx=null)
  {
    return Rx.Observable.create(obs=>{
      let val = null
      if(ctx&&ctx.tg&&ctx.tg.last_name)
        val = ctx.tg.last_name
      obs.next(val)
      obs.complete()
    })
  }

}

module.exports = LastNameGenerator

