/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../../log').m('TelegramMessage')
let g18n = require('../../../g18n')

const fs = require('fs')

const Node = require('../../node/node')

class MessageNode extends Node
{

  constructor(parent,mdl,isNew=false)
  {
    super(parent,mdl,isNew)

    this._type = 'messagenode'

    this._open = false
    this._update = false
    this._priority = 0
    this.onSended = new Rx.Subject()

    this._media = []
    //this._msgType = 'text'
    //this._text = ''
    //this._keyboard = null
    //this._inline = null
    //this._media = []
    //this._files = []
    //this._sticker = null
    //this._location = null
    ///this._audio = null
    ///this._voice = null
    ///this._video = null

    this._iface = this.M('telegram')
  }

  setIface(val)
  {
    this._iface = val
  }

  addFile(f)
  {
    this._media.push(f)
  }

  priority(val)
  {
    if(typeof val != 'undefined' && val>=0)
      this._proirity = val
    return this._priority
  }

  init(ctx=null)
  {
    return Rx.Observable.create(obs=>{
      if (!ctx)
        return this.obsEnd(obs,this)

      //console.log(['start initing tg message from ctx2',ctx._type,upd])

      let mid = null
      let upd = ctx.update[ctx.updateType]
      if (ctx._type == 'calback_query')
      {
        mid = upd.message.message_id
      } else {
        mid = upd.message_id
        if (ctx._replyMode)
        {
          //console.log(['init._replyMode upd',upd,mid])
          mid = upd.reply_to_message.message_id
          this.fp('sender',ctx._replyUser)
          this.fp('chat',ctx._replyChat)
          ctx._replyMode = false
        } else {
          this.fp('sender',ctx._users[0])
          this.fp('chat',ctx._chat)
        }
      }
      if (mid)
        this.f('messageId',mid)

      if (this.fp('chat'))
        this._priority = this.fp('chat').f('priority')
      //this.field('users').all(ctx._users)
      this.f('type',ctx._type)

      this.f('raw',upd)
      if (upd.date)
        this.f('date',upd.date)
      //else
        //this.f('data',new Date())

      if (ctx._type=='text')
      {
        let txt = upd.text || null
        if (txt&&txt.length)
          this.f('text',txt)
        return this.obsEnd(obs,this)
      }
      /**/
      if (ctx._type=='callback_query'&&upd.data)
      {
        this.f('text',upd.data)
        return this.obsEnd(obs,this)
      }
      //this.field('users').clear()

      this.obsEnd(obs,this)
    })
  }

  open() {
    if (this.finilized()) return
    this._open = true
  }
  close() { this._open = false }
  opened() { return this._open }

  finilized() { return this.sended() }
  finilize(src)
  {
    return Rx.Observable.create(obs=>{
      //console.log(['finilization',src])
      if (!src.message_id)
        return this.obsErr(obs,src)
      this._open = false
      this.f('messageId',src.message_id)
      this.f('raw',src)
      this.f('date',src.date)
      if (src.text)
      {
        this.f('type','text')
        this.f('text',src.text)
      }
      let $t = []
      if (this._media.length)
      {
        let isPhoto = false
        let isDoc = false
        if (src.document&&src.document.file_id)
          isDoc = true
        if (src.photo&&src.photo.length)
          isPhoto = true
        //console.log('msg finilize',src)
        this._media.forEach(m=>{
          if (isDoc)
          {
            if (m.obj.f('size')==src.document.file_size)
            {
              //found!
              m.obj.f('tgid',src.document.file_id)
              $t.push(m.obj.save())
            }
          }
          if (isPhoto)
          {
            src.photo.forEach(photo=>{
              if (photo.file_size == m.obj.f('size'))
              {
                //found!
                m.obj.f('tgid',photo.file_id)
                $t.push(m.obj.save())
              }
            })
          }
          //console.log(m.obj._model)
        })
      }
      //$t.push(this.save())
      Rx.concat(...$t).subscribe(onem=>{
        log.log('one saved')
      },err=>{
        log.err('saving media failed')
        console.log(err)
        this.obsErr(obs,err)
      },()=>{
        this.obsEnd(obs,this)
      })
    })
  }
  //sender() { return this.field('users').get(0) }
  sended() {
    let ret = !!this.f('messageId')&&!this._update
    //console.log(['sended?',ret])
    return ret
  }

  _hasContent()
  {
    let t = this.f('text')
    if (t&&t.length)
      t = t.trim()
    if (t&&t.length)
      return true
    if (this._media.length)
      return true
    return false
  }

  sendable()
  {
    let chat = this.fp('chat')
    let sender = this.f('sender')
    let hasContent = this._hasContent()

    if(!chat)
      return false
    if(!this.opened()||this.finilized())
      return false
    if(!this._update&&sender&&!this._iface.me().eq(sender))
      return false
    if (!hasContent)
      return false
    return true
  }

  send()
  {
    this._iface.sendMessage(this)
  }

  update()
  {
    //test for updatetable and set update flag
    this._update = true
    this._iface.sendMessage(this)
  }

  sendDone(res)
  {
    //console.log(['send done',this.fp('chat').f('title'),res])
    //this.onSended.next(res)
    this.onSended.next(res)
  }

  beforeSave()
  {
    return Rx.Observable.create(obs=>{
      log.success('before save!')
      //TODO
      this.field('files').clear()

      //console.log(this.toObject())
      this.obsEnd(obs,this)
    })
  }

  /*
  afterSave()
  {
    return Rx.Observable.create(obs=>{
      log.success('after save!')
      this.obsEnd(obs,this)
    })
  }
  /**/

  compile()
  {
    return Rx.Observable.create(obs=>{
      let ok = this.sendable()
      if (!ok)
        return this.obsEnd(obs,null)
      let chat = this.fp('chat')
      let text = this.f('text')
      let kbd = this.f('keyboard')
      let btns = this.f('inline')
      //console.log(['compiling',text,kbd])
      let ret = {
        //chatId: 
        upd: null,
        type: 'none',
        kbdType: 'none',
        kbd: []
      }
      if (text&&text.length)
      {
        //text message
        ret.type = 'text'
        ret.text = text
      }
      if (this._media.length)
      {
        if (this._media.length==1)
        {
          let ff = this._media[0]
          let inf = ff.obj.f('info')
          if (inf.type !='image')
          {
            ret.type='file'
            ret.file = {
              source: ff.source,
              filename: ff.filename,
              caption: ff.caption
            }
          } else {
            ret.type='image'
            ret.image = {
              source: fs.readFileSync(ff.source),
              //filename: ff.filename,
              caption: ff.caption,
              type: 'photo'
            }
          }
          //console.log(ff.obj.f('tgid'))
          //if (ff.obj.f('tgid')&&ff.obj.f('tgid').length)
            //ret.image.media = ff.obj.f('tgid')
        } else {
          ret.type='gallery'
          //console.log(['!!!GALLERY'])
          ret.media = this._media.map(x=>{
            let ret2 = {
              media: {source: fs.readFileSync(x.source)},
              //filename: x.filename,
              caption: x.caption,
              type: 'photo'
            }
            //if (x.obj.f('tgid')&&x.obj.f('tgid').length)
              //ret2.media = x.obj.f('tgid')
            //console.log(ret2)
              //ret2 = {
                //file: x.obj.f('tgid')
              //}
            return ret2
          })
        }
      }
      //console.log(ret)
      let cConf = chat.f('conf')
      //console.log([ret,chat.f('conf')])
      if (kbd&&kbd.length&&cConf['answer:keyboards'])
      {
        ret.kbdType='keyboard'
        ret.kbd = kbd
      }
      if (btns&&btns.length)
      {
        ret.kbdType='inline'
        ret.kbd = btns
      }
      //console.log(['sending'],ret)
      if (this._update)
      {
        ret.upd = this.f('messageId')
        //console.log(['upd',ret])
      }
      this.obsEnd(obs,ret)
    })
  }


  saveToChatHistory()
  {
    return Rx.of(this.fp('chat')).pipe(
      RxO.mergeMap(chat=>{
        let cConf = chat.f('conf')
        let cHist = chat.f('history')
        let cMem = chat.f('memory')
        //console.log([cConf,cHist,cMem])
        if (!cHist)
          return Rx.of(null)
        log.warn('saving to history!',chat.f('title'))
        return this.save().pipe(RxO.mergeMap(self=>{
          let msgs = chat.field('messages').all()
          let dm = null
          if (msgs.length>=cMem)
            dm = msgs.pop()
          msgs.unshift(self)
          //console.log(['dm',dm])
          chat.field('messages').all(msgs)
          let ccnt = chat.f('counter') || 0
          chat.f('counter',ccnt+1)
          let ctcnt = chat.f('totalCounter') || 0
          chat.f('totalCounter',ctcnt+1)
          chat.f('lastMessage',chat.field('lastMessage').now())
          return chat.save().pipe(RxO.mergeMap(x=>{
            if (!dm)
              return Rx.of(null)
            let did = dm
            if (typeof dm.id == 'function')
              did = dm.id()
            return this.C('tgmessage').removeNodes({_id:did})
          }))
        }))
      }),
      RxO.map(x=>null)
    )
  }
}

module.exports = MessageNode
