/*
  This file is part of TakatanJS software.
  @author abrakadobr
  @version 2.5.58
  @website https://js.takatan.tk
*/


let Rx = require('rxjs')
let RxO = require('rxjs/operators')

let log = require('../../log').m('TelegramBotRouter')
let g18n = require('../../g18n')

const CoreObject = require('../core/abstract/object')
const Cmd = require('./cmd')

const Screen = require('../bot/screen/screen')

class TelegramBotRouter extends CoreObject
{
  constructor(parent)
  {
    super(parent)
  }

  init()
  {
  }

  _search(ctx,testfn,withIsolate=true)
  {
    return Rx.Observable.create(obs=>{
      let sender = ctx.user()
      let chat = ctx.chat()
      let chatt = chat.f('type')

      // TODO DIRTY HARDFIX
      if (chatt == 'channel')
        chatt = 'group'

      let main = null
      let empty = null
      let $mains = []
      let $empties = []
      let before = []
      let after = []

      this.C('screengroup').findNodes({},{
        list: true,
        sort: {priority:-1},
        populate: 2
      }).subscribe(scgs=>{
        let allowed = []
        let isolationScope = sender.f('isolateScope')
        //dirty fix to make "super isolation" for inline mode
        //currently used for tutorials
        if (typeof isolationScope == 'string' && isolationScope.endsWith('+'))
        {
          isolationScope = isolationScope.slice(0,-1)
          withIsolate = true
        }
        let isolationScreen = sender.f('isolateScreen')
        let isolationScreengroup = sender.f('isolateScreengroup')

        let doIso = false
        if (withIsolate&&isolationScope)
        {
          //console.log([isolationScreen,isolationScreengroup])
          if(isolationScope=='priv'&&chatt=='private')
            doIso = true
          if(isolationScope=='private'&&chatt=='private')
            doIso = true
          if(isolationScope=='grp'&&chatt=='group')
            doIso = true
          if(isolationScope=='xgrp'&&chatt=='supergroup')
            doIso = true
          if(isolationScope=='pub'&&chatt!='private')
            doIso = true
          if(isolationScope=='all')
            doIso = true
        }
          log.warn('DO ISO?',{scope:isolationScope,ok:doIso})
        scgs.forEach(scg=>{
          //console.log(['scg',scg.id(),scg.field('code').get(),scg.field('priority').get()])
          //check isolation
          /**/
          if (doIso&&isolationScreengroup)
          {
            //log.warn('has isolation scg')
            if (scg.eq(isolationScreengroup))
              allowed.push(scg)
            return
          }
          /**/
          //check chat allow overrides
          let groupAllowed = false
          let groupRole = 'screengroup.'+scg.f('code')+':'+chatt
          //log.test('can?',groupRole)
          if (sender.can(groupRole,true))
            groupAllowed = true
          if (chat.field('allow').has(scg.id()))
            groupAllowed = true
          if (chat.field('deny').has(scg.id()))
            groupAllowed = false
          if (groupAllowed)
            allowed.push(scg)
        })
        allowed.forEach(scg=>{
          scg.field('screens').forEach(sc=>{
            if (!sc) return
            if (!sc.f('enabled')) return
            if (doIso&&isolationScreen)
            {
              //log.warn('has isolation sc')
              if (sc.eq(isolationScreen))
                $mains.push(sc)
              return
            }
            sc.screengroup(scg)
            let action = sc.f('action')
            if (action == 'before_'+ctx.type())
            {
              before.push(sc)
              return
            }
            if (action == 'after_'+ctx.type())
            {
              after.push(sc)
              return
            }
            if (action!=ctx.type()) return
            if (action.includes('group_chat')) //join/leave
            {
              $mains.push(sc)
              return
            }

            //TESTFN
            let basicOk = false
            let emptyOk = false
            let bt = testfn(sc)
            if (bt&&bt.basic) basicOk = true
            if (bt&&bt.empty) emptyOk = true
            if (basicOk)
              $mains.push(sc)
            if (emptyOk)
              $empties.push(sc)
          })
        })
        //ok, now we have lists main/empties/before/after. need to test them and get finals
        //let's get main 1st. if we don't have main - b4 and after we don't care
        let $srch = []
        let mainFound = new Rx.Subject()
        $mains.forEach(sc=>{
          $srch.push(this.M('logic').testLogicRx(sc,ctx).pipe(RxO.mergeMap(testRes=>{
            //console.log(['screen router, screen tested',sc.f('title'),testRes,ctx.toObject()])
            if (doIso&&isolationScreen)
            {
              if (sc.eq(isolationScreen))
              {
                main = sc
                mainFound.next(1)
              }
              return Rx.of(null)
            }
            //log.info('main screen tested',[sc.f('title'),testRes])
            if(!testRes)
              return Rx.of(null)
            if (main)
              return Rx.of(null)
            main = sc
            mainFound.next(1)
          })))
        })
        $empties.forEach(sc=>{
          $srch.push(this.M('logic').testLogicRx(sc,ctx).pipe(RxO.mergeMap(testRes=>{
            //log.info('empty screen tested',[sc.f('title'),testRes])
            if(!testRes)
              return Rx.of(null)
            if (main)
              return Rx.of(null)
            main = sc
            mainFound.next(1)
          })))
        })
        Rx.concat(...$srch).pipe(RxO.takeUntil(mainFound)).subscribe(osc=>{
          //log.test('one more screen tested')
          //console.log([main,osc,'one more screen test chain done'])
        },err=>{
          log.err('error happens on search!')
          console.log(err)
        },()=>{
          //log.warn('search finished!')
          //log.success('found screen to execute!',main.f('title'))
          this.obsEnd(obs,{
            main: main,
            before: before,
            after: after
          })
        })
      })
    })
  }


  onMessage(ctx)
  {
    log.info('message',[ctx.type(),ctx.user().titles(),ctx.chat().f('title'),ctx.chat().f('type')])
      //console.log(ctx.raw())
    let sender = ctx.user()
    let chat = ctx.chat()

    let msgText = ctx.upd().text || ''
    let cmd = new Cmd(ctx,msgText)
    ctx.cmd(cmd)

    this._search(ctx,sc=>{
      let ret = {
        basic: false,
        empty: false
      }
      if (!msgText||!msgText.length)
        return ret
      let actionData = sc.f('actionData')
      if (!actionData||!actionData[ctx.type()])
        return ret
      let ad = actionData[ctx.type()]
      //basic
      let basicOk = false
      if (ad.hasCommand&&ad.command!=''&&ad.command==cmd.command())
        basicOk = true
      if (ad.hasKey&&ad.key!=''&&ad.key==cmd.key())
        basicOk = true
      //new
      if (ad.hasRx&&ad.rx&&ad.rx!='')
      {
        let rxline = ad.rx
        let rg = null
        if (rxline.startsWith('/')&&rxline.endsWith('/i'))
        {
          rxline = rxline.slice(1,-2)
          rg = new RegExp(rxline,'i')
        } else {
          rg = new RegExp(rxline)
        }
        let ok = rg.test(cmd.raw())
        if (ok)
          basicOk = true
      }
      if (basicOk)
        ret.basic = true
      if (!ad.hasCommand&&!ad.hasKey&&!ad.hasRx)
        ret.empty = true
      return ret
    }).subscribe(sres=>{
      //log.warn('search finished!')
      if (!sres.main)
        return
      log.success('found screen to execute!',sres.main.f('title'))
      let $exec = []
      /**/
      let omsg = ctx.message()
      if (omsg)
      {
        //console.log(['saving message',omsg.toObject()])
        omsg.f('screen',sres.main)
        //ctx.message().field('',main)
        $exec.push(omsg.saveToChatHistory())
      }
      /**/
      sres.before.forEach(xsc=>{
        $exec.push(this.M('logic').testLogicRx(xsc,ctx).pipe(RxO.mergeMap(x=>{
          if(!x) return Rx.of(null)
          return xsc.populate(3).pipe(RxO.mergeMap($xsc=>{
            return $xsc.execute(ctx).pipe(RxO.catchError(exe=>{
              return Rx.of({success:false,error:exe,code:'SCREEN_EXECUTION_ERROR'})
            }))
          }))
        })))
      })
      $exec.push(sres.main.populate(2).pipe(RxO.mergeMap($xsc=>{
        return $xsc.execute(ctx).pipe(RxO.catchError(exe=>{
          log.err('execution error!')
          console.log(exe)
          return Rx.of({success:false,error:exe,code:'SCREEN_EXECUTION_ERROR'})
        }))
      })))
      sres.after.forEach(xsc=>{
        $exec.push(this.M('logic').testLogicRx(xsc,ctx).pipe(RxO.mergeMap(x=>{
          if(!x) return Rx.of(null)
          return xsc.populate(2).pipe(RxO.mergeMap($xsc=>{
            return $xsc.execute(ctx).pipe(RxO.catchError(exe=>{
              log.err('execution error!')
              console.log(exe)
              return Rx.of({success:false,error:exe,code:'SCREEN_EXECUTION_ERROR'})
            }))
          }))
        })))
      })
      Rx.concat(...$exec).subscribe(exRes=>{
        if (!exRes) return
        log.info('screen executed',exRes)
      },err=>{
        //should never come here
        log.err('screens execution error!!')
        console.log(err)
      },()=>{
        log.success('all executions complete')
      })

    })

  }


  onCallbackQuery(ctx)
  {
    let data = ctx.upd().data||null
    log.info('callback_query',[ctx.user().titles(),ctx.chat().field('title').get(),data])
    if (!data)
      return
    let $srch = null
    let cmd = new Cmd(ctx,'')
    ctx.cmd(cmd)
    if (data.startsWith('sid:'))
    {
      let sid = data.slice(4)
      $srch = this.C('screen').findNode({_id:sid}).pipe(RxO.map(x=>{
        return { main: x, before: [], after: []}
      }))
    } else {
      cmd.fromCBQ(data)
      ctx.cmd(cmd)
      $srch = this._search(ctx,sc=>{
        //console.log(sc.f('title'))
        let ret = {
          basic: false,
          empty: false
        }
        if (!data||!data.length)
          return ret
        //let cmd = new Cmd(ctx,msgText)
        //ctx.cmd(cmd)
        let actionData = sc.f('actionData')
        if (!actionData||!actionData[ctx.type()])
          return ret
        let ad = actionData[ctx.type()]
        //basic
        let basicOk = false
        if (ad.hasCommand&&ad.command!=''&&ad.command==cmd.command())
          basicOk = true
        //new
        if (ad.hasRx&&ad.rx&&ad.rx!='')
        {
          let rxline = ad.rx
          let rg = null
          if (rxline.startsWith('/')&&rxline.endsWith('/i'))
          {
            rxline = rxline.slice(1,-2)
            rg = new RegExp(rxline,'i')
          } else {
            rg = new RegExp(rxline)
          }
          let ok = rg.test(cmd.raw())
          if (ok)
            basicOk = true
        }
        if (basicOk)
          ret.basic = true
        if (!ad.hasCommand&&!ad.hasRx)
          ret.empty = true
        return ret
      },false)
    }
      //this.C('screen').findNode({_id:sid},{populate:2}).subscribe(sc=>{
    $srch.subscribe(sc=>{
      //log.test('search result',[!!sc])
      if (!sc||!sc.main)
        return
      log.success('found screen to execute',sc.main.f('title'))
      let omsg = ctx.message()
      omsg.f('screen',sc.main)
      //omsg.save().pipe(
        //RxO.mergeMap(_=>sc.main.populate(2)),
      sc.main.populate(2).pipe(
        RxO.mergeMap($sc=>$sc.execute(ctx))
      ).subscribe(exRes=>{
        let ad = sc.main.f('actionData')
        let ans = ''
        if (ad&&ad.callback_query&&ad.callback_query.text)
          ans = ad.callback_query.text
        if (!ans||!ans.length)
        {
          ctx._rawctx.answerCbQuery('')
          log.success('executed with no answer')
          return
        }
        this.M('template').compile(ans,ctx).subscribe(ansc=>{
          ctx._rawctx.answerCbQuery(ansc)
          log.success('executed with answer',ansc)
        },err=>{
          ctx._rawctx.answerCbQuery('')
          log.err('compiling callback answer error',err)
        })
      },err=>{
        log.err('callbackscreen execution error!')
        console.log(err)
      })
    },err=>{
      log.err('screen not found!',sid)
      console.log(err)
    })
  }



}

module.exports = TelegramBotRouter
