let Rx = require('rxjs')
let RxO = require('rxjs/operators')

const TJS = require('../includes')

let log = TJS.log.m('ShopModule')

class ShopModule extends TJS.CoreModule
{

  moduleLoad()
  {
    return Rx.Observable.create(obs=>{
      //this.M('field').registerFieldType(TTField)
      //this.M('bot/reactions').registerReactionType(TestReaction)
      //this.M('bot/messages').registerMessageType('tutorialtest',TestMsg)
      //log.test('loading')
      //this.moduleInstall().subscribe(_=>{
        this.obsEnd(obs)
      //})
    })
  }
 
  moduleInstall()
  {

    return Rx.Observable.create(obs=>{
      let $t = []

      //lessons data bundle
      let bndOrders = this.M('bundle').bundle('shop_orders',true)
      bndOrders.name(g18n.t('Shop orders'))
      bndOrders.desc(g18n.t('Orders, done in shop'))
      bndOrders.addFlag('system')
      bndOrders.addField({name:g18n.t('Order ID'),code:'oid',type:'string',flags:['system','logic','title','template']})
      bndOrders.addField({name:g18n.t('Status'),code:'status',type:'string',flags:['system','template','logic']})
      bndOrders.addField({name:g18n.t('Owner'),code:'owner',type:'relation',flags:['system','template','logic'],conf:{ops:[{source:'manual',manual:'user'}]}})
      bndOrders.addField({name:g18n.t('Products'),code:'products',type:'relation',flags:['system','template','logic']})
      bndOrders.addField({name:g18n.t('Comment'),code:'comment',type:'string',flags:['system','template','logic'],conf:{ops:[{source:'manual',manual:true}]}})
      bndOrders.addField({name:g18n.t('Total'),code:'total',type:'number',flags:['system','template','logic']})
      bndOrders.addField({name:g18n.t('Order data'),code:'data',type:'any',flags:['system','logic','template'],def:null})


      log.log('installing bundle',bndOrders.code())
      $t.push(bndOrders.save(true,true))


      /*
      //course data bundle
      let bndCourse = this.M('bundle').bundle('tutorial_course',true)
      bndCourse.name(g18n.t('Tutorial course'))
      bndCourse.desc(g18n.t('Tutorial course contains lessons with tests'))
      bndCourse.addFlag('system')
      bndCourse.addField({name:g18n.t('Enabled'),code:'enabled',type:'boolean',flags:['system','logic','title','template'],def:true})
      bndCourse.addField({name:g18n.t('Code'),code:'code',type:'string',flags:['system','template','logic']})
      bndCourse.addField({name:g18n.t('Name'),code:'name',type:'string',flags:['system','template','logic','title']})
      bndCourse.addField({name:g18n.t('Description'),code:'desc',type:'string',flags:['system','template','logic'],conf:{ops:[{source:'manual',manual:true}]}})
      bndCourse.addField({name:g18n.t('Brief'),code:'brief',type:'string',flags:['system','template','logic'],conf:{ops:[{source:'manual',manual:true}]}})
      bndCourse.addField({name:g18n.t('Access logic'),code:'access_logic',type:'logicfilter',flags:['system','logic']})
      bndCourse.addField({name:g18n.t('Lessons'),code:'lessons',type:'relation',flags:['system','template','logic'],conf:{ops:[{source:'manual',manual:'tutorial_lesson'}]},quantity:0})
      bndCourse.addField({name:g18n.t('Users data'),code:'usersdata',type:'any',flags:['system','logic','template'],def:null})

      log.log('installing bundle',bndCourse.code())
      $t.push(bndCourse.save(true,true))
      /**/

      //modify user bundle
      let bndUser = this._core.module('bundle').bundle('user')
      if(!bndUser.hasField('shop_cart'))
      {
        bndUser.addField({name:g18n.t('Shop cart'),code:'shop_cart',type:'relation',flags:['system','template','logic'],conf:{ops:[{source:'manual',manual:'shop_orders'}]}})
        log.log('modifying user bundle')
        $t.push(bndUser.save())
      }


      Rx.concat(...$t).subscribe(()=>{},obs.error,()=>{
        log.success('module installed')
        this.obsEnd(obs)
      })
 
    })
  }



}

module.exports = ShopModule
