let Rx = require('rxjs')
let RxO = require('rxjs/operators')

const TJS = require('../includes')

let log = TJS.log.m('TutorialTestMessage')
let g18n = TJS.g18n

class TutorialTestMessage extends TJS.AbstractMessage
{

  /**/
  sendQuestion(vtest,ctx,user,cfg,qi)
  {
    return Rx.Observable.create(obs=>{
      let ud = user.f('testsData')
      let test = cfg.target
      let tcode = test.f('code')
      let tdata = test.f('testdata')

      vtest.f('qsend',qi)
      vtest.f('qwait',qi-1)

      let $msg = this.C('tgmessage').newNode()
      $msg.open()
      $msg.f('type',ctx.type())
      $msg.f('sender',this.M('telegram').me())
      $msg.f('chat',ctx.chat())
      $msg.f('screen',this.screen())
      $msg.f('text',tdata.questions[qi].question)
      let btns = []
      let cols = cfg.kbdrowsize
      if (cols < 2 ) cols = 1
      if (cfg.mode=='keyboard')
      {
        btns = tdata.questions[qi].answers.filter(b=>b.label!='**').map(b=>b.label)
        btns = btns.reduce((acc,v)=>{
          let row = acc.length
          if (!row)
            acc.push([])
          else
            row--
          if (acc[row].length==cols)
          {
            row++
            acc.push([])
          }
          acc[row].push(v)
          return acc
        },[])
        $msg.f('keyboard',btns)
      } else {
        btns = tdata.questions[qi].answers.map((b,bi)=>{return {text:b.label,callback_data:bi}})
        btns = btns.reduce((acc,v)=>{
          let row = acc.length
          if (!row)
            acc[row] = []
          else
            row--
          if (acc[row].length==cols)
          {
            row++
            acc.push([])
          }
          acc[row].push(v)
          return acc
        },[])
        $msg.f('inline',btns)
      }
      if (!$msg.sendable())
        return this.obsErr(obs,{code:'TEST_MESSAGE_NOT_SENDABLE?',qi:qi})
      $msg.onSended.subscribe(msgRes=>{
        log.info('message sended',msgRes)
        if (!msgRes||!msgRes.success||msgRes.error)
        {
          //ctx.f('error',ctx.f('error')+1)
          //console.log(['msgres',msgRes])
          return this.obsErr(obs,{code:'TEST_MESSAGE_NOT_SENDED?',qi:qi})
        }
        //ctx.f('sended',ctx.f('sended')+1)
        ud[tcode].pos = qi
        user.f('testsData',ud)
        console.log(['ud',ud])
        let where = ctx.chat().f('type')
        user.f('isolateScope',where+'+')
        user.f('isolateScreen',this.screen())
        user.f('isolateScreengroup',this.screen().screengroup())
        user.save().subscribe($u=>{
          this.obsEnd(obs)
        },e=>this.obsErr(obs,e))
      },err=>{
        //ctx.f('error',ctx.f('error')+1)
        console.log(['ERRORRRRR!!!! tutorial/testmsg.js sending '+qi+' msg'])
        this.obsErr(obs,err)
      })
      $msg.send()
    })
  }
  /**/
  
  execute(ctx) //tutorial test message executing
  {
    return Rx.Observable.create(obs=>{
      let rct = this.field('reactions').getp(0)

      rct.screen(this.screen())
      rct.message(this)

      rct.execute(ctx,null).subscribe(cfg=>{
        if(!cfg||!cfg.ok)
          return this.obsErr(obs,{code:'TEST_CONFIGURATION_FAILED'})

        let u = ctx.user()
        let ud = u.f('testsData')
        let tcode = cfg.target.f('code')
        let tdata = cfg.target.f('testdata')

        let vtest = new TJS.VirtualNode(ctx)
        vtest.addField({code:'state',type:'string'})
        vtest.addField({code:'textOnInline',type:'boolean'})
        vtest.addField({code:'qsend',type:'number'})
        vtest.addField({code:'qwait',type:'number'})
        vtest.addField({code:'araw',type:'string'})
        vtest.addField({code:'ascore',type:'number'})
        vtest.addField({code:'tscore',type:'number'})
        vtest.addField({code:'trang',type:'string'})
        vtest.addField({code:'tcode',type:'string'})
        ctx.addNode(vtest,'tutorialtest')

        if (typeof ud != 'object')
          ud = {}
        //ud = {}
        if (typeof ud[tcode] != 'object')
        {
          //1st time calling test = start
          ud[tcode] = {
            name: cfg.target.f('name'),
            state: 'open',
            pos: -1,
            answers: [],
            score: 0,
            rang: '',
            started: new Date(),
            completed: null
          }
            u.f('testsData',ud)
        } else {
          //test data already exists for this user
          //if test is closed - need restart it
          if (ud[tcode].state != 'open')
          {
            ud[tcode] = {
              name: cfg.target.f('name'),
              state: 'open',
              pos: -1,
              answers: [],
              score: 0,
              rang: '',
              started: new Date(),
              completed: null
            }
            u.f('testsData',ud)
          }
        }
        vtest.f('state',ud[tcode].state)
        vtest.f('tcode',tcode)

        //let's get test state
        let pos = ud[tcode].pos

        //console.log(['we are at pos',pos,'of',tdata.questions.length])
        //all questions has answers!
        //how we come here?
        if (pos == tdata.questions.length)
          return this.obsErr(obs,{code:'TEST_DONE_HOW_WE_COME_HERE?'})

        //we need to send 1st question,
        //we don't wait any answers
        if (pos == -1)
        {
          this.sendQuestion(vtest,ctx,u,cfg,0).subscribe(_=>this.obsEnd(obs),err=>this.obsErr(obs,err))
          return
        }


        //we have to grab answer
        let ai = -1 //not found
        let ans = {
          raw: '',
          ai: -1,
          score: 0
        }
        if (cfg.mode=='keyboard')
        {
          //keyboards and text answers
          ans.raw = ctx.cmd().raw()
          let stars = -1
          tdata.questions[pos].answers.forEach((aans,ansi)=>{
            if (aans.label.toLowerCase()==ans.raw.toLowerCase())
              ai = ansi
            if (aans.label=='**')
              stars = ansi
          })
          if (ai==-1&&stars!=-1)
            ai = stars
        } else {
          //inline buttons answers
          ai = parseInt(ctx.cmd().command())
          if (ctx.type()=='text')
          {
            vtest.f('textOnInline',true)
            if (cfg.noinlinetext)
              return this.obsEnd(obs)
          }
          if (ai >= tdata.questions[pos].answers.length)
          {
            log.err('parsing inline answer number is greater then answers amount. set to last')
            ai = tdata.questions[pos].answers.length-1
          }
          if (ai>=0)
            ans.raw = '['+ai+']>> '+tdata.questions[pos].answers[ai].label
        }
        if (ai>=0)
        {
          ans.ai = ai
          ans.score = tdata.questions[pos].answers[ai].points
        }
        //console.log(['ans',ans])
        ud[tcode].answers[pos] = ans
        u.f('testsData',ud)

        if (tdata.questions.length-1 == pos)
        {
          //it was last question, test completed
          //calculating results
          ud[tcode].completed = new Date()
          ud[tcode].score = ud[tcode].answers.reduce((acc,ans)=>acc+(parseInt(ans.score)||0),0)
          if (ud[tcode].score < tdata.success)
            ud[tcode].state = 'fail'
          else
            ud[tcode].state = 'success'
          //console.log(['TEST COMPLETED',ud[tcode]])
          let max = 0
          ud[tcode].rang = ''
          tdata.rangs.forEach(r=>{
            let rr = parseInt(r.points)
            if (ud[tcode].score>=0)
            {
              if (rr>ud[tcode].score)
                return
              if (rr<max)
                return
              max = rr
              ud[tcode].rang = r.name
            } else {
              if (rr<ud[tcode].score)
                return
              if (rr>max)
                return
              max = rr
              ud[tcode].rang = r.name
            }
          })
          //console.log(ud[tcode].rang)
          vtest.f('state',ud[tcode].state)
          vtest.f('tscore',ud[tcode].score)
          vtest.f('trang',ud[tcode].rang)

          u.f('testsData',ud)
          let where = ctx.chat().f('type')
          u.field('isolateScope').clear()
          u.field('isolateScreen').clear()
          u.field('isolateScreengroup').clear()
          u.save().subscribe($u=>{
            this.obsEnd(obs)
          },e=>this.obsErr(obs,e))
        } else {
          //it was not last question
          //increase position and send question
          //console.log(['TEST NEXT Q',ud[tcode]])
          this.sendQuestion(vtest,ctx,u,cfg,ud[tcode].pos+1).subscribe(_=>this.obsEnd(obs),err=>this.obsErr(obs,err))
          return
        }

        //console.log(['oooops! pos not 0',pos])
        //this.obsEnd(obs)

      },err=>this.obsErr(obs,err))
    })
  }


}

module.exports = TutorialTestMessage
