export default {
  name: 'tjs-pages-navbar',
  props: ['page','pages','lngi','onlyIfTop'],
  /**/
  data: ()=>{
    return {
      canTop: true,
    }
  },
  /**/
  methods: {
    backPage() {
      if (!Array.isArray(this.pages))
        return null
      let siblings = this.pages.filter(x=>x.parentCode==this.page.parentCode).sort((a,b)=>a.sortOrder-b.sortOrder)
      let ret = null
      let bf = null
      siblings.forEach(sb=>{
        if (ret) return
        if (sb.code==this.page.code)
        {
          ret = bf
          return
        }
        bf = sb
      })
      return ret?ret: this.topPage()
    },
    topPage()
    {
      if (!Array.isArray(this.pages))
        return null
      let pg = this.pages.reduce((acc,x)=>x.code==this.page.parentCode?x:acc,null)
      return pg
    },
    nextPage()
    {
      if (!Array.isArray(this.pages))
        return null
      let childs = this.pages.filter(x=>x.parentCode==this.page.code).sort((a,b)=>a.sortOrder-b.sortOrder)
      if (childs[0])
        return childs[0]
      let siblings = this.pages.filter(x=>x.parentCode==this.page.parentCode).sort((a,b)=>a.sortOrder-b.sortOrder)
      let ret = null
      let bf = null
      siblings.forEach(sb=>{
        if (ret) return
        if (bf)
        {
          ret = sb
          return
        }
        if (sb.code==this.page.code)
        {
          bf = sb
          return
        }
      })
      if (ret)
        return ret
      let tp = this.topPage()
      if (!tp)
        return null
      let psibs = this.pages.filter(x=>x.parentCode==tp.parentCode).sort((a,b)=>a.sortOrder-b.sortOrder)
      ret = null
      bf = null
      psibs.forEach(sb=>{
        if (ret) return
        if (bf)
        {
          ret = sb
          return
        }
        if (sb.code==tp.code)
          bf = sb
      })
      return ret
    }
  },
  computed: {
    hasBack(){
      return !!this.backPage()
    },
    hasTop(){
      if (!this.page.parentCode.includes('/'))
        return false
      let tp = this.topPage()
      if (!tp)
        return false
      let bp = this.backPage()
      if (!bp)
        return this.canTop
      if (bp.code==tp.code)
        return false
      return this.canTop
    },
    hasNext(){
      return !!this.nextPage()
    },
    btnBack()
    {
      let bp = this.backPage()
      if (!bp)
        return ''
      let tp = this.topPage()
      if (tp&&bp.code==tp.code)
        return 'arrowleftup'
      return 'arrowleft'
    },
    btnTop()
    {
      return 'arrowup'
    },
    btnNext()
    {
      let np = this.nextPage()
      if (!np)
        return ''
      if (np.parentCode==this.page.parentCode)
        return 'arrowright'
      if (np.parentCode==this.page.code)
        return 'arrowrightdown'
      return 'arrowrightup'
    },
    doShow()
    {
      return this.onlyIfTop ? !!this.topPage() : true
    }
  },
  template: `
    <div v-if="doShow" class="row">
      <div class="col-4 text-left">
        <router-link v-if="hasBack" :to="'/'+backPage().url[lngi]" class="btn btn-light border rounded btn-sm">
          <tg-emoji :imgw="16" :code="btnBack"></tg-emoji>
          <span>{{backPage().title[lngi]}}</span>
        </router-link>
      </div>
      <div class="col-4 text-center">
        <router-link v-if="hasTop" :to="'/'+topPage().url[lngi]" class="btn btn-light border rounded btn-sm">
          <tg-emoji :imgw="16" :code="btnTop"></tg-emoji>
          <span>{{topPage().title[lngi]}}</span>
        </router-link>
      </div>
      <div class="col-4 text-right">
        <router-link v-if="hasNext" :to="'/'+nextPage().url[lngi]" class="btn btn-light border rounded btn-sm">
          <span>{{nextPage().title[lngi]}}</span>
          <tg-emoji :imgw="16" :code="btnNext"></tg-emoji>
        </router-link>
      </div>
    </div>
  `,
  created()
  {
    //console.log(this.onlyIfTop)
  }
}
