export default {
  name: 'tjs-sidemenu',
  props: ['pages'],
  data: ()=>{
    return {
      currentPath: '',
      currentPage: '',
      mode: '',
      lvl: ''
    }
  },
  computed: {
    items(){
      if(!this.pages||!this.pages.length)
        return []
      return this.pages//.sort((a,b)=>a.sortOrder-b.sortOrder)
      //let u = this.currentPath.slice(1)
      //let curr = this.pages.reduce((acc,x)=>{
        //if (acc) return acc
        //if (x.url.includes(u)) return x
        //return acc
      //},null)
      //if (!curr) return []
      //this.lvl = curr.parentCode
      //return this.pages//.map(x=>x.parentCode==curr.code)
    }
    /*
      <div v-if="mode.startsWith('guide')" class="list-group mb-2">
    </div>

       */
  },
  template: `
    <div class="">

        <div class="list-group-item">
          <div>
            <tg-emoji :code="'greenheart'"></tg-emoji>
            <router-link v-if="!$router.currentRoute.path.startsWith('/ru')" to="/" class="ml-3">Takatan JS</router-link>
            <router-link v-if="$router.currentRoute.path.startsWith('/ru')" to="/ru/" class="ml-3">Takatan JS</router-link>
          </div>
          <div>
            <tjs-pages-tree
              :items="items"
              :lvl="'front'"
              :limit="!mode.startsWith('front')"
            ></tjs-pages-tree>
          </div>
        </div>

        <div v-if="!mode.startsWith('guide')" class="list-group-item">
          <div>
            <tg-emoji :code="'books'"></tg-emoji>
            <router-link v-if="!$router.currentRoute.path.startsWith('/ru')" to="/guide" class="ml-3">Guides</router-link>
            <router-link v-if="$router.currentRoute.path.startsWith('/ru')" to="/ru/guide" class="ml-3">Инструкции</router-link>
          </div>
        </div>


        <div v-if="mode.startsWith('guide')" class="list-group-item">
          <div>
            <tg-emoji :code="'greenbook'"></tg-emoji>
            <router-link v-if="!$router.currentRoute.path.startsWith('/ru')" to="/guide/greenbook" class="ml-3">Green book</router-link>
            <router-link v-if="$router.currentRoute.path.startsWith('/ru')" to="/ru/guide/greenbook" class="ml-3">Зелёная книга</router-link>
          </div>
          <div>
            <tjs-pages-tree
              :items="items"
              :lvl="'guide/greenbook'"
              :limit="!mode.startsWith('guide/greenbook')"
            ></tjs-pages-tree>
          </div>
        </div>

        <div v-if="mode.startsWith('guide')" class="list-group-item">
          <div>
            <tg-emoji :code="'orangebook'"></tg-emoji>
            <router-link v-if="!$router.currentRoute.path.startsWith('/ru')" to="/guide/orangebook" class="ml-3">Orange book</router-link>
            <router-link v-if="$router.currentRoute.path.startsWith('/ru')" to="/ru/guide/orangebook" class="ml-3">Оранжевая книга</router-link>
          </div>
          <div>
            <tjs-pages-tree
              :items="items"
              :lvl="'guide/orangebook'"
              :limit="!mode.startsWith('guide/orangebook')"
            ></tjs-pages-tree>
          </div>
        </div>

        <div v-if="mode.startsWith('guide')" class="list-group-item">
          <tg-emoji :code="'redbook'"></tg-emoji>
          <router-link v-if="!$router.currentRoute.path.startsWith('/ru')" to="/guide/redbook" class="ml-3">Red book</router-link>
          <router-link v-if="$router.currentRoute.path.startsWith('/ru')" to="/ru/guide/redbook" class="ml-3">Красная книга</router-link>
          <tjs-pages-tree
            :items="items"
            :lvl="'guide/redbook'"
            :limit="!mode.startsWith('guide/redbook')"
          ></tjs-pages-tree>
        </div>

        <div v-if="mode.startsWith('guide')" class="list-group-item">
          <tg-emoji :code="'bluebook'"></tg-emoji>
          <router-link v-if="!$router.currentRoute.path.startsWith('/ru')" to="/guide/bluebook" class="ml-3">Blue book</router-link>
          <router-link v-if="$router.currentRoute.path.startsWith('/ru')" to="/ru/guide/bluebook" class="ml-3">Синяя книга</router-link>
          <tjs-pages-tree
            :items="items"
            :lvl="'guide/bluebook'"
            :limit="!mode.startsWith('guide/bluebook')"
          ></tjs-pages-tree>
        </div>

        <div class="list-group-item">
          <div>
            <tg-emoji :code="'hammerandwrench'"></tg-emoji>
            <router-link v-if="!$router.currentRoute.path.startsWith('/ru')" to="/api" class="ml-3">Development API</router-link>
            <router-link v-if="$router.currentRoute.path.startsWith('/ru')" to="/ru/api" class="ml-3">API разработки</router-link>
          </div>
          <div>
            <tjs-pages-tree
              :items="items"
              :lvl="'api'"
              :limit="!mode.startsWith('api')"
            ></tjs-pages-tree>
          </div>
        </div>



      </div>



  `,
  methods: {
    lnk(item) {
      return '/'+item.url[0]
    }
  },
  watch: {
    $route(v) {
      this.currentPath = v.path
      this.mode = 'front'
      if (this.currentPath.includes('/api'))
        this.mode = 'api'
      if (this.currentPath.includes('/guide'))
        this.mode = 'guide'
      if (this.currentPath.includes('/guide/greenbook'))
        this.mode = 'guide/greenbook'
      if (this.currentPath.includes('/guide/orangebook'))
        this.mode = 'guide/orangebook'
      if (this.currentPath.includes('/guide/redbook'))
        this.mode = 'guide/redbook'
      if (this.currentPath.includes('/guide/bluebook'))
        this.mode = 'guide/bluebook'
    }
  }

}
